SystemOrganization addCategory: #'SeasideTesting-Core'!
SystemOrganization addCategory: #'SeasideTesting-Examples'!
SystemOrganization addCategory: #'SeasideTesting-Html Entities'!
SystemOrganization addCategory: #'SeasideTesting-Platform'!
SystemOrganization addCategory: #'SeasideTesting-TestRunner'!
SystemOrganization addCategory: #'SeasideTesting-Mods'!

!SeasidePlatformSupport class methodsFor: '*SeasideTesting' stamp: 'cds 2/4/2005 08:09'!
issueRequest: anHttpRequest responseSemaphore: semaphore
	| response |
	[response := WAKom default processHttpRequest: anHttpRequest.
	semaphore signal] fork.
	semaphore wait.
	^ response! !

!SeasidePlatformSupport class methodsFor: '*SeasideTesting' stamp: 'mb 7/23/2007 17:55'!
parseSeasideDocumentFrom: aStream
	| parser |
	parser := SCSeasideResponseParser on: aStream.
	parser driver entities
		at: 'nbsp' put: (DTDEntityDeclaration name: 'nbsp' value: ' ').
	parser document: SCSeasideResponse new.
	parser startDocument.
	parser parseDocument.
	^parser document! !

!SeasidePlatformSupport class methodsFor: '*SeasideTesting' stamp: 'mb 8/3/2007 15:31'!
testSuiteClass
	^TestSuite! !

WADecoration subclass: #SCAnswerChecker
	instanceVariableNames: 'hasAnswer answerValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCAnswerChecker methodsFor: 'accessing' stamp: 'cds 6/19/2004 20:47'!
answerValue
	^answerValue! !

!SCAnswerChecker methodsFor: 'call/answer' stamp: 'mb 9/25/2007 23:12'!
handleAnswer: anObject 
	(super handleAnswer: anObject)
		ifTrue: [^ true]
		ifFalse: 
			[hasAnswer := true.
			answerValue := anObject].
	^ false! !

!SCAnswerChecker methodsFor: 'accessing' stamp: 'mb 9/25/2007 23:12'!
hasAnswer
	^ hasAnswer ifNil: [hasAnswer := false]! !

TestCase subclass: #SCComponentTestCase
	instanceVariableNames: 'app browser pseudomain handler debugging responseSema runnerTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

SCComponentTestCase subclass: #SCAnchorDemoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCAnchorDemoTest methodsFor: 'Running' stamp: 'cds 12/17/2005 18:48'!
testAnchor
	self newApplicationWithRootClass: SCAnchorDemo.
	self establishSession.
	self followAnchor: (self lastResponse anchorWithId: 'first').
	self assert: (self lastResponse entitiesNamed: 'h3') first contentString 
				= 'pressed'! !

SCComponentTestCase subclass: #SCCanvasComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCCanvasComponentTest methodsFor: 'running' stamp: 'cds 9/24/2006 11:30'!
testFormComponent
	| form |
	self newApplicationWithRootClass: SCTestComponent7.
	form := self establishSession forms first.
	self submitForm: form pressingButton: form buttons first.
	self
		assert: (self componentAnswered: true)! !

!SCComponentTestCase class methodsFor: 'dispatcher' stamp: 'cds 9/11/2007 17:32'!
clearEntryPoints
	"self clearEntryPoints"
	(WADispatcher default entryPoints includesKey: self entryPointKey)
		ifTrue: [WADispatcher default register: (WADispatcher named: self entryPointKey)]! !

!SCComponentTestCase class methodsFor: 'dispatcher' stamp: 'cds 6/12/2005 12:33'!
dispatcher
	self ensureEntryPointExists.
	^WADispatcher default entryPoints at: self entryPointKey! !

!SCComponentTestCase class methodsFor: 'dispatcher' stamp: 'cds 3/23/2007 09:29'!
ensureEntryPointExists
	(WADispatcher default entryPoints includesKey: self entryPointKey)
		ifFalse: [WADispatcher default register: (WADispatcher named: self entryPointKey)]! !

!SCComponentTestCase class methodsFor: 'dispatcher' stamp: 'cds 6/12/2005 12:28'!
entryPointKey
	^'activeTests'! !

!SCComponentTestCase class methodsFor: 'Testing' stamp: 'cds 9/23/2006 00:57'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not
	have TestCase instances built from it"
	^ self name = #SCComponentTestCase! !

!SCComponentTestCase methodsFor: 'answering' stamp: 'mb 9/25/2007 23:28'!
answer
	| checker |
	checker := runnerTask answerChecker.
	^checker hasAnswer
		ifTrue: [checker answerValue]
		ifFalse: [self error: 'Component did not answer.']
! !

!SCComponentTestCase methodsFor: 'dispatcher' stamp: 'cds 6/13/2005 14:20'!
applicationPathForClass: aClass
	^aClass name, '_' , testSelector asString
! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'cds 7/17/2004 19:23'!
back
	^self browser back! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'cds 6/19/2004 00:46'!
backAndRefresh
	self back.
	^self refresh! !

!SCComponentTestCase methodsFor: 'accessing' stamp: 'mb 9/25/2007 23:28'!
browser
	^ browser
		ifNil: [browser := SCBrowserSimulator new
			responseSemaphore: self responseSemaphore;
			yourself]! !

!SCComponentTestCase methodsFor: 'private' stamp: 'mb 9/25/2007 23:29'!
checkResponseForDebugging: response 
	| a finalResponse |
	finalResponse := response.
	self isDebugging
		ifTrue: [a := response anchorWithLabel: 'Debug' ifNone: [^finalResponse].
			[finalResponse := self followAnchor: a] fork.
			self halt: 'Browser waiting for response, proceed when you''re done debugging.'].
	^ finalResponse! !

!SCComponentTestCase methodsFor: 'component' stamp: 'cds 1/11/2006 16:24'!
component
	^runnerTask component! !

!SCComponentTestCase methodsFor: 'answering' stamp: 'cds 1/11/2006 16:10'!
componentAnswered
	^ runnerTask answerChecker hasAnswer! !

!SCComponentTestCase methodsFor: 'answering' stamp: 'cds 1/11/2006 16:10'!
componentAnswered: value 
	| checker |
	checker := runnerTask answerChecker.
	^checker hasAnswer and: [checker answerValue = value]! !

!SCComponentTestCase methodsFor: 'subclass hooks' stamp: 'cds 5/25/2006 13:01'!
configureApplicationForComponent: aComponentClass 
	"This gets sent when SeasideTesting creates the entry point for 
	your test class. Override it to configure your application's 
	session class or other 'preferences' but be sure to do the super 
	send. "
	app preferenceAt: #deploymentMode put: true.
	pseudomain := SCTestingPseudomain new.
	app preferenceAt: #mainClass put: pseudomain.
	handler := SCTestErrorHandler new.
	handler case: self.
	app preferenceAt: #errorHandler put: handler.
	runnerTask := SCRunnerTask new.
	runnerTask componentClass: aComponentClass.
	app preferenceAt: #rootComponent put: runnerTask! !

!SCComponentTestCase methodsFor: 'running' stamp: 'cds 9/23/2006 00:58'!
debug
	self resources
		do: [:res | res isAvailable
				ifFalse: [^ res signalInitializationError]].
	[(self class selector: testSelector) makeDebugging; runCase]
		ensure: [self resources
				do: [:each | each reset]]! !

!SCComponentTestCase methodsFor: 'dispatcher' stamp: 'cds 6/12/2005 12:33'!
dispatcher
	^self class dispatcher! !

!SCComponentTestCase methodsFor: 'private' stamp: 'cds 9/7/2004 21:09'!
errorOccurred: e 
	self isDebugging
		ifFalse: [self error: 'An error occured during request processing']! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'cds 11/16/2007 21:35'!
establishSession
	^ self
		checkResponseForDebugging: (self browser establishSessionAtBase: app baseUrl displayString)! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'mb 11/13/2006 17:18'!
followAnchor: anAnchor 
	| response |
	anAnchor basePath: app basePath.
	response := self browser followAnchor: anAnchor.
	^self checkResponseForDebugging: response! !

!SCComponentTestCase methodsFor: 'component' stamp: 'cds 1/11/2006 16:24'!
frontMostComponent
	^ runnerTask component visiblePresentersDo: [:each |
		each isDecoration ifFalse: [^each]]! !

!SCComponentTestCase methodsFor: 'accessing' stamp: 'cds 11/21/2007 14:11'!
isDebugging
	^debugging ifNil: [false]! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'cds 7/17/2004 19:23'!
lastResponse
	^self browser lastResponse! !

!SCComponentTestCase methodsFor: 'private' stamp: 'mb 9/25/2007 23:29'!
makeDebugging
	debugging := true! !

!SCComponentTestCase methodsFor: 'application' stamp: 'cds 12/20/2005 08:49'!
newApplicationWithRootClass: aComponentClass 
	^self newApplicationWithRootClass: aComponentClass initializeWith: nil! !

!SCComponentTestCase methodsFor: 'application' stamp: 'cds 9/10/2007 14:38'!
newApplicationWithRootClass: aComponentClass createWith: aBlock 
	app := SCTesterApplication
				path: (self applicationPathForClass: aComponentClass).
	app testCase: self.
	app configuration addAncestor: WARenderLoopConfiguration instance.
	self dispatcher
		register: app.
	self configureApplicationForComponent: aComponentClass.
	runnerTask createComponentBlock: aBlock.
	^ app! !

!SCComponentTestCase methodsFor: 'application' stamp: 'mb 8/2/2007 13:25'!
newApplicationWithRootClass: aComponentClass initializeWith: aBlock 
	app := SCTesterApplication
				path: (self applicationPathForClass: aComponentClass).
	app testCase: self.
	app configuration addAncestor: WARenderLoopConfiguration instance.
	self dispatcher register: app.
	self configureApplicationForComponent: aComponentClass.
	runnerTask initializationBlock: aBlock.
	^ app! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'cds 7/17/2004 19:23'!
refresh
	^self browser refresh! !

!SCComponentTestCase methodsFor: 'application' stamp: 'mb 9/25/2007 23:29'!
responseSemaphore
	^ responseSema
		ifNil: [responseSema := Semaphore new]! !

!SCComponentTestCase methodsFor: 'running' stamp: 'mb 9/25/2007 23:29'!
run: aResult
	debugging := false.
	^super run: aResult! !

!SCComponentTestCase methodsFor: 'running' stamp: 'cds 9/7/2004 22:26'!
runCaseAsFailure: aSemaphore 
	self makeDebugging.
	super runCaseAsFailure: aSemaphore! !

!SCComponentTestCase methodsFor: 'accessing' stamp: 'cds 9/7/2004 23:00'!
session
	^ pseudomain storedSession! !

!SCComponentTestCase methodsFor: 'subclass hooks' stamp: 'cds 3/19/2006 12:12'!
sessionCreated: aSession
	"This is a hook for subclasses that want to perform specific actions in response to session creation (such as initializing a database connection)."! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'cds 12/20/2005 12:07'!
submitForm: form
	^self submitForm: form pressingButton: nil! !

!SCComponentTestCase methodsFor: 'request/response' stamp: 'cds 9/10/2007 14:36'!
submitForm: form pressingButton: button 
	| response |
	response := self browser submitForm: form pressingButton: button.
	^self checkResponseForDebugging: response! !

SCComponentTestCase subclass: #SCDoNothingTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCDoNothingTaskTest methodsFor: 'running' stamp: 'cds 1/11/2006 16:27'!
testNotInfiniteLoop
	"Make sure that tasks which don't call anything don't cause an infinite loop"
	self newApplicationWithRootClass: SCDoNothingTask.
! !

SCComponentTestCase subclass: #SCExceptionDuringCallbackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCExceptionDuringCallbackTest methodsFor: 'as yet unclassified' stamp: 'cds 8/16/2005 10:59'!
couldBeTestException
	self newApplicationWithRootClass: SCExceptionDuringCallback.
	self establishSession.
	self should: [self followAnchor: self lastResponse anchors first]
		raise: SCTestException! !

SCComponentTestCase subclass: #SCExceptionDuringRenderingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCExceptionDuringRenderingTest methodsFor: 'as yet unclassified' stamp: 'cds 8/16/2005 10:59'!
couldBeTestException
	self newApplicationWithRootClass: SCExceptionDuringRendering.
	self should: [self establishSession] raise: SCTestException
! !

SCComponentTestCase subclass: #SCFileDownloadComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCFileDownloadComponentTest commentStamp: 'cds 6/25/2007 16:33' prior: 0!
Thanks to Liliana Ivan for furnishing this test case.!

!SCFileDownloadComponentTest methodsFor: 'tests' stamp: 'cds 6/25/2007 16:32'!
testDownloadFileLink
	self newApplicationWithRootClass: SCFileDownloadComponent.
	self establishSession.
	self followAnchor: (self lastResponse anchorWithLabel: 'Download file').
	self assert: self lastResponse contents 
				= 'some text that may be read from somewhere'! !

SCComponentTestCase subclass: #SCFormDemoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCFormDemoTest methodsFor: 'Running' stamp: 'cds 12/17/2005 18:48'!
testDisplay
	| form |
	self newApplicationWithRootClass: SCFormDemo.
	self establishSession.
	form := self lastResponse forms first.
	form textInputWithId: 'name' value: 'Bob Smith'.
	form textInputWithId: 'age' value: '40'.
	self submitForm: form pressingButton: form buttons first.
	self assert: (self lastResponse entitiesNamed: 'h3') first contentString 
				= 'Hello Bob Smith.  You are 40 years old.'! !

SCComponentTestCase subclass: #SCInputWithLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCInputWithLabelTest methodsFor: 'running' stamp: 'cds 9/9/2007 13:07'!
testFindInput
	| labels form inputs |
	self newApplicationWithRootClass: SCInputWithLabel.
	self establishSession.
	form := self lastResponse forms first.
	labels := form labelsWithText: 'some text'.
	self assert: labels size = 1.
	inputs := form inputsWithLabel: 'some text'.
	self assert: inputs size = 1.
	inputs first value: 'type something'.
	self submitForm: form pressingButton: form buttons first.
	self assert: self component value = 'type something'! !

SCComponentTestCase subclass: #SCMiniCalendarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCMiniCalendarTest methodsFor: 'Running' stamp: 'cds 6/14/2005 16:21'!
testSelectedDate
	| selected anchors |
	self newApplicationWithRootClass: WAMiniCalendar initializeWith: [:cal |
		cal canSelectBlock: [:date | true].
		cal selectBlock: [:date | selected := date]].
	self establishSession.
	self assert: selected isNil.
	anchors := self lastResponse anchorsWithLabel: (Date today dayOfMonth printString).
	self followAnchor: anchors last.
	self assert: selected = Date today.! !

SCComponentTestCase subclass: #SCSampleComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testAnswer
	self newApplicationWithRootClass: SCTestComponent4.
	self establishSession.
	self followAnchor: (self lastResponse anchorWithLabel: 'third link').
	self assert: (self componentAnswered: 1234)! !

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testBack
	self newApplicationWithRootClass: SCTestComponent4.
	self establishSession.
	self followAnchor: (self lastResponse anchorWithLabel: 'first link').
	self assert: self component firstSent.
	self deny: self component secondSent.
	self followAnchor: (self lastResponse anchorWithLabel: 'second link').
	self backAndRefresh.
	self assert: self component firstSent.
	self deny: self component secondSent! !

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 6/13/2005 10:20'!
testComponent1
	self newApplicationWithRootClass: SCTestComponent1.
	self establishSession.
	self assert: (self lastResponse stringWithId: 'main') = 'hello'! !

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testComponent2
	self newApplicationWithRootClass: SCTestComponent2.
	self establishSession.
	self followAnchor: (self lastResponse anchorWithId: 'first').
	self assert: self component firstSent.
	self deny: self component secondSent.
	self followAnchor: (self lastResponse anchorWithLabel: 'second link').
	self assert: self component firstSent.
	self assert: self component secondSent! !

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testComponent3
	| form |
	self newApplicationWithRootClass: SCTestComponent3.
	self establishSession.
	form := self lastResponse forms first.
	form textInputWithId: 'field1' value: 'bob'.
	form textInputWithId: 'field2' value: 'jane'.
	self submitForm: form pressingButton: form buttons first.
	self assert: self component field1 = 'bob'.
	self assert: self component field2 = 'jane'! !

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 10/17/2005 13:22'!
testComponent6
	| form list |
	self newApplicationWithRootClass: SCTestComponent6.
	self establishSession.
	form := self lastResponse forms first.
	list := form selectListWithId: 'theList'.
	list selectOptionWithText: 'b'.
	self submitForm: form pressingButton: form buttons first.
	self assert: self component selectedItem = #b! !

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testFrontMost
	self newApplicationWithRootClass: SCTestComponent5.
	self establishSession.
	self assert: (self frontMostComponent isKindOf: SCTestComponent5).
	self followAnchor: self lastResponse anchors first.
	self assert: (self frontMostComponent isKindOf: SCTestComponent4).
	self followAnchor: (self lastResponse anchorWithLabel: 'third link').
	self assert: (self frontMostComponent isKindOf: SCTestComponent5)! !

!SCSampleComponentTest methodsFor: 'tests' stamp: 'cds 11/11/2005 09:08'!
testFrontMostIsDialog
	self newApplicationWithRootClass: SCTestComponent5.
	self establishSession.
	self followAnchor: (self lastResponse anchors second).
	self assert: (self frontMostComponent isKindOf: WAFormDialog)! !

SCComponentTestCase subclass: #SCSetBacktrackingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCSetBacktrackingTest commentStamp: 'cds 9/24/2006 00:52' prior: 0!
Test whether Set instances are properly backtracked or not.  This test will probably not pass unless my extensions to Set in the package SC are loaded.  Beware, if you don't pass this test then don't trust that Set instances are properly backtracked by Seaside.!

!SCSetBacktrackingTest methodsFor: 'tests' stamp: 'cds 10/17/2005 23:22'!
testAdd
	| form input |
	self newApplicationWithRootClass: SCSetBacktrackingComponent.
	self establishSession.
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	self assert: (self component set includes: 'entry1')! !

!SCSetBacktrackingTest methodsFor: 'tests' stamp: 'cds 10/17/2005 23:22'!
testRemove
	| form input |
	self newApplicationWithRootClass: SCSetBacktrackingComponent.
	self establishSession.
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	self assert: (self component set includes: 'entry1').
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'remove').
	self deny: (self component set includes: 'entry1').
! !

!SCSetBacktrackingTest methodsFor: 'tests' stamp: 'mb 7/11/2007 17:55'!
testSequence1
	| form input |
	self newApplicationWithRootClass: SCSetBacktrackingComponent.
	self establishSession.
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry2'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry3'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	
	self assert: (self component set includesAllOf: (Array with: 'entry1' with: 'entry2' with: 'entry3')).
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'remove').
	self deny: (self component set includes: 'entry1').
	self back.
	self backAndRefresh.
	self assert: (self component set includes: 'entry1').

	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'remove').
	self deny: (self component set includes: 'entry1').

! !

!SCSetBacktrackingTest methodsFor: 'tests' stamp: 'mb 7/11/2007 17:56'!
testSequence2
	| form input |
	self newApplicationWithRootClass: SCSetBacktrackingComponent.
	self establishSession.
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry2'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry3'.
	self submitForm: form pressingButton: (form buttonWithValue: 'add').
	
	self assert: (self component set includesAllOf: (Array with: 'entry1' with: 'entry2' with: 'entry3')).
	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'remove').
	self deny: (self component set includes: 'entry1').
	self back.
	self backAndRefresh.
	self assert: (self component set includes: 'entry1').

	form := self lastResponse forms first.
	input := form textInputWithId: 'input'.
	input value: 'entry1'.
	self submitForm: form pressingButton: (form buttonWithValue: 'remove').
	self deny: (self component set includes: 'entry1').
	self backAndRefresh.
	self assert: (self component set includes: 'entry1')
! !

SCComponentTestCase subclass: #WAAllTestsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!WAAllTestsTest methodsFor: 'utility' stamp: 'mb 10/12/2007 00:28'!
htmlTestClass
	^SCHtmlTest! !

!WAAllTestsTest methodsFor: 'utility' stamp: 'mb 10/12/2007 00:12'!
inputTestClass
	^SCInputTest
! !

!WAAllTestsTest methodsFor: 'utility' stamp: 'stan shepherd 8/15/2009 09:41'!
selectedComponent
	^ self component navigation contents! !

!WAAllTestsTest methodsFor: 'tests' stamp: 'mb 7/11/2007 17:44'!
testButtons
	| form |
	self newApplicationWithRootClass: self htmlTestClass.
	self establishSession.
	form := self lastResponse formWithId: 'button-form'.
	self
		submitForm: form
		pressingButton: (form buttonWithValue: '5').
	self assert: self component number = 5.
	form := self lastResponse formWithId: 'button-form'.
	self
		submitForm: form
		pressingButton: (form buttonWithValue: '1').
	self assert: self component number = 1! !

!WAAllTestsTest methodsFor: 'tests' stamp: 'mb 7/11/2007 17:44'!
testCheckbox
	| form |
	self newApplicationWithRootClass: self htmlTestClass.
	self establishSession.
	form := self lastResponse formWithId: 'checkbox-form'.
	(form checkboxWithId: 'cb-a') check.
	self submitForm: form pressingButton: form buttons first.
	self assert: self component booleanList first value.
	form := self lastResponse formWithId: 'checkbox-form'.
	(form checkboxWithId: 'cb-a') uncheck.
	self submitForm: form pressingButton: form buttons first.
	self deny: self component booleanList first value! !

!WAAllTestsTest methodsFor: 'tests' stamp: 'cds 6/13/2005 16:05'!
testException
	| form |
	self newApplicationWithRootClass: WAExceptionTest.
	form := self establishSession forms first.
	self submitForm: form pressingButton: (form buttonWithValue: 'Yes').
	self assert: (self lastResponse containsString: 'Caught:')! !

!WAAllTestsTest methodsFor: 'tests' stamp: 'stan shepherd 8/15/2009 11:11'!
testNavigation
	"modified the last assertion from 'Form Elements' to 'SCForm Elements'. Previously the assertion failed, and this appears to be what is intended. 
	...Stan Shepherd"
	| form |
	self newApplicationWithRootClass: SCAllTests.
	self establishSession.
	self
		followAnchor: (self lastResponse anchorWithLabel: 'SCInput').
	self assert: self selectedComponent class = self inputTestClass.
	self assert: self selectedComponent numericInput = 42.
	form := self lastResponse forms first.
	form textInputWithId: 'numeric-input' value: '753'.
	self submitForm: form pressingButton: form buttons first.
	self assert: self selectedComponent numericInput = 753.
	self
		followAnchor: (self lastResponse anchorWithLabel: 'SCForm Elements').
	self assert: self selectedComponent class = self htmlTestClass.
	form := self lastResponse formWithId: 'radio-form'.
	form activateRadioButtonWithId: 'a-on'.
	self submitForm: form pressingButton: form buttons first.
	self assert: self selectedComponent booleanList first value.
	form := self lastResponse formWithId: 'radio-form'.
	form activateRadioButtonWithId: 'a-off'.
	self submitForm: form pressingButton: form buttons first.
	self deny: self selectedComponent booleanList first value.
	self
		followAnchor: (self lastResponse anchorWithLabel: 'Parent').
	self assert: self selectedComponent class = WAParentTest.
	self
		followAnchor: (self lastResponse anchorWithLabel: 'swap parent').
	self
		assert: (self lastResponse containsString: 'Test green!!').
	self assert: (self lastResponse anchorWithLabel: 'Html') isNil.
	form := self lastResponse forms first.
	self
		submitForm: form
		pressingButton: (form buttonWithValue: 'Ok').
	self assert: (self lastResponse anchorWithLabel: 'SCForm Elements') notNil! !

!WAAllTestsTest methodsFor: 'tests' stamp: 'mb 9/25/2007 12:26'!
testSelect
	| form |
	self newApplicationWithRootClass: self htmlTestClass.
	self establishSession.
	form := self lastResponse formWithId: 'select-form'.
	(form selectListWithId: 'select-list')
		selectOptionWithText: '7'.
	self submitForm: form pressingButton: form buttons first.
	self assert: self component number = 7.
	form := self lastResponse formWithId: 'select-form'.
	self
		should: [(form selectListWithId: 'select-list')
				selectOptionWithText: '15']
		raise: Error.
	(form selectListWithId: 'select-list')
		value: '2'.
	self submitForm: form pressingButton: form buttons first.
	self assert: self component number = 2.
	self should: [form buttonWithValue: '22'] raise: Error.! !

!WAAllTestsTest methodsFor: 'tests' stamp: 'mb 7/11/2007 17:44'!
testTextAreaInput
	| form |
	self newApplicationWithRootClass: self htmlTestClass.
	self establishSession.
	form := self lastResponse formWithId: 'textarea-form'.
	self 
		assert: (form entityWithId: 'textarea-banner' containsText: 'Hello world!!').
	self assert: self component message = 'Hello world!!'.
	form textInputWithId: 'textarea-message' value: 'bob'.
	self submitForm: form pressingButton: form buttons first.
	form := self lastResponse formWithId: 'textarea-form'.
	self assert: (form entityWithId: 'textarea-banner' containsText: 'bob').
	self assert: self component message = 'bob'! !

!WAAllTestsTest methodsFor: 'tests' stamp: 'mb 7/11/2007 17:44'!
testTextInput
	| form |
	self newApplicationWithRootClass: self htmlTestClass.
	self establishSession.
	form := self lastResponse formWithId: 'textInput-form'.
	self 
		assert: (form entityWithId: 'textInput-banner' containsText: 'Hello world!!').
	self assert: self component message = 'Hello world!!'.
	form textInputWithId: 'text-message' value: 'bob'.
	self submitForm: form pressingButton: form buttons first.
	form := self lastResponse formWithId: 'textInput-form'.
	self assert: (form entityWithId: 'textInput-banner' containsText: 'bob').
	self assert: self component message = 'bob'! !

SCComponentTestCase subclass: #WACounterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!WACounterTest methodsFor: 'tests' stamp: 'cds 10/17/2004 20:23'!
testBack
	self newApplicationWithRootClass: WACounter.
	self establishSession.
	self
		followAnchor: (self lastResponse anchorWithLabel: '++').
	self
		followAnchor: (self lastResponse anchorWithLabel: '++').
	self assert: self component count = 2.
	self back.
	self
		followAnchor: (self lastResponse anchorWithLabel: '++').
	self assert: self component count = 2! !

!WACounterTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testDecrement
	self newApplicationWithRootClass: WACounter.
	self establishSession.
	self followAnchor: (self lastResponse anchorWithLabel: '--').
	self assert: self component count = -1.
	self followAnchor: (self lastResponse anchorWithLabel: '--').
	self assert: self component count = -2! !

!WACounterTest methodsFor: 'tests' stamp: 'cds 9/24/2006 00:44'!
testIncrement
	self newApplicationWithRootClass: WACounter.
	self establishSession.
	self
		followAnchor: (self lastResponse anchorWithLabel: '++').
	self assert: self component count = 1.
	self
		followAnchor: (self lastResponse anchorWithLabel: '++').
	self assert: self component count = 2! !

!WACounterTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testInitialState
	self newApplicationWithRootClass: WACounter.
	self establishSession.
	self assert: self component count = 0! !

SCComponentTestCase subclass: #WAYesOrNoDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!WAYesOrNoDialogTest methodsFor: 'tests' stamp: 'cds 7/26/2004 20:13'!
testNo
	| form |
	self newApplicationWithRootClass: WAYesOrNoDialog.
	form := self establishSession forms first.
	self submitForm: form pressingButton: (form buttonWithValue: 'No').
	self assert: (self componentAnswered: false)! !

!WAYesOrNoDialogTest methodsFor: 'tests' stamp: 'cds 6/13/2005 16:59'!
testYes
	| form |
	self newApplicationWithRootClass: WAYesOrNoDialog.
	form := self establishSession forms first.
	self submitForm: form pressingButton: (form buttonWithValue: 'Yes').
	self assert: self answer = true! !

!WAPresenter class methodsFor: '*SeasideTesting' stamp: 'cds 7/10/2004 13:09'!
hasTestSuite
	^self suite notNil! !

!WAPresenter class methodsFor: '*SeasideTesting' stamp: 'cds 7/10/2004 13:09'!
suite
	^ (Smalltalk hasClassNamed: self testSuiteName)
		ifTrue: [(Smalltalk classNamed: self testSuiteName) suite]! !

!WAPresenter class methodsFor: '*SeasideTesting' stamp: 'cds 7/10/2004 13:09'!
testSuiteName
	^(self name , 'Test') asSymbol! !

WAAllTests subclass: #SCAllTests
	instanceVariableNames: 'classLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCAllTests methodsFor: '*SeasideTesting-Mods' stamp: 'stan shepherd 8/15/2009 10:54'!
classLabels
	"WAAllTests uses a selector with the actual class name. SCAllTests refers to the  meaningful labels which were presumably in a prior version of WAAllTests. This method fills in those previous labels"
	^ classLabels
		ifNil: [Dictionary
				with: SCInputTest -> 'SCInput'
				with: SCHtmlTest -> 'SCForm Elements'
				with: WAParentTest -> 'Parent']! !

!SCAllTests methodsFor: '*SeasideTesting-Mods' stamp: 'stan shepherd 8/15/2009 10:55'!
labelForClass: aClass
	"see comment in >>classLabels"
	^ self classLabels at: aClass ifAbsent: aClass name
	! !

!SCAllTests methodsFor: 'accessing' stamp: 'stan shepherd 8/15/2009 10:56'!
navigation
	"WAAllTests keeps the current component in current, where it used to be in navigation"
	^current! !

!SCAllTests methodsFor: '*SeasideTesting-Mods' stamp: 'stan shepherd 8/15/2009 11:01'!
renderContentOn: html 
	"WAAllTests now has a selector for choosing the test component, so the
	anchors used in SCAllTests are not present. This method renders the
	choices as anchors"
	html heading: 'Functional Seaside Test Suite'.
	html
		table: [html
				tableData: [classes
						do: [:class | 
							html anchor
								callback: [current contents: class new];
								
								with: (self labelForClass: class).
							html break]];
				
				tableData: [html div class: 'window';
						
						with: [html render: current contents]]]! !

WAComponent subclass: #SCAnchorDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCAnchorDemo class methodsFor: 'seaside' stamp: 'cds 6/13/2005 13:00'!
canBeRoot
	^true! !

!SCAnchorDemo methodsFor: 'rendering' stamp: 'cds 6/13/2005 13:00'!
firstPressed
	self inform: 'pressed'! !

!SCAnchorDemo methodsFor: 'rendering' stamp: 'mb 7/11/2007 16:59'!
renderContentOn: html 
	html anchor
		id: 'first';
		callback: [self firstPressed];
		with: 'first link'! !

WAComponent subclass: #SCExceptionDuringCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCExceptionDuringCallback class methodsFor: 'testing' stamp: 'cds 6/28/2005 15:48'!
canBeRoot
	^true! !

!SCExceptionDuringCallback methodsFor: 'rendering' stamp: 'mb 7/11/2007 16:58'!
renderContentOn: html 
	html anchor 
		callback: [SCTestException signal];
		with: 'throw exception'! !

WAComponent subclass: #SCExceptionDuringRendering
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCExceptionDuringRendering methodsFor: 'rendering' stamp: 'cds 7/17/2005 11:51'!
renderContentOn: html 
	SCTestException signal! !

WAComponent subclass: #SCFileDownloadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCFileDownloadComponent commentStamp: 'LM 4/24/2007 10:12' prior: 0!
Seaside tutorial
http://www.shaffer-consulting.com/david/Seaside/RenderingBasics/index.html
testing various components
!

!SCFileDownloadComponent class methodsFor: 'testing' stamp: 'LM 5/17/2007 10:19'!
canBeRoot
	^true.! !

!SCFileDownloadComponent methodsFor: 'rendering' stamp: 'mb 7/11/2007 17:00'!
renderContentOn: html 
	html heading
		level:1;
		with: 'Tests'.
	html break.
	html anchor
		document: 'some text that may be read from somewhere'
		mimeType: 'text/plain'
		fileName: 'myfilename.txt';
		with: 'Download file'! !

WAComponent subclass: #SCFormDemo
	instanceVariableNames: 'name age'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCFormDemo class methodsFor: 'seaside' stamp: 'cds 6/13/2005 16:15'!
canBeRoot
	^true! !

!SCFormDemo methodsFor: 'accessing' stamp: 'cds 6/13/2005 16:16'!
age
	^age! !

!SCFormDemo methodsFor: 'accessing' stamp: 'cds 6/13/2005 16:16'!
age: anObject
	age := anObject! !

!SCFormDemo methodsFor: 'rendering' stamp: 'cds 6/13/2005 16:15'!
displayInfo
	self inform: 'Hello ' , name , '.  You are ' , age , ' years old.'! !

!SCFormDemo methodsFor: 'accessing' stamp: 'cds 6/13/2005 16:16'!
name
	^name! !

!SCFormDemo methodsFor: 'accessing' stamp: 'cds 6/13/2005 16:16'!
name: anObject
	name := anObject! !

!SCFormDemo methodsFor: 'rendering' stamp: 'mb 7/11/2007 17:00'!
renderContentOn: html
	html form with: [
		html text: 'Name: '.
		html textInput
			id: 'name';
			on: #name of: self.
		html break.
		html text: 'Age: '.
		html textInput
			id: 'age';
			on: #age of: self.
		html break.
		html submitButton
			callback: [self displayInfo]; 
			value: 'Display']! !

WAComponent subclass: #SCInputWithLabel
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCInputWithLabel methodsFor: 'rendering' stamp: 'cds 9/9/2007 12:42'!
renderContentOn: html
	html form with:
		[html label for: 'someField'; with: 'some text'.
		html textInput id: 'someField'; callback: [:v | value := v].
		html submitButton callback: [self answer]; value: 'button']! !

!SCInputWithLabel methodsFor: 'accessing' stamp: 'cds 9/9/2007 12:42'!
value
	^ value! !

!SCInputWithLabel methodsFor: 'accessing' stamp: 'cds 9/9/2007 12:42'!
value: anObject
	^ value := anObject! !

WAComponent subclass: #SCSetBacktrackingComponent
	instanceVariableNames: 'set value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCSetBacktrackingComponent methodsFor: 'initialization' stamp: 'cds 7/13/2007 10:17'!
initialize
	super initialize.
	set := Set new.
	! !

!SCSetBacktrackingComponent methodsFor: 'rendering' stamp: 'cds 3/23/2007 09:55'!
renderContentOn: html
	html form:
		[html textInput
			id: 'input';
			callback: [:v | value := v].
		html submitButton
			callback: [set add: value];
			value: 'add'.
		html submitButton
			callback: [set remove: value];
			value: 'remove']! !

!SCSetBacktrackingComponent methodsFor: 'accessing' stamp: 'cds 10/17/2005 23:19'!
set
	^set! !

!SCSetBacktrackingComponent methodsFor: 'accessing' stamp: 'cds 7/13/2007 10:17'!
states
	^Array with: set! !

WAComponent subclass: #SCTestBuilder
	instanceVariableNames: 'component requests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestBuilder class methodsFor: 'testing' stamp: 'cds 6/29/2005 11:42'!
canBeRoot
	^true! !

!SCTestBuilder methodsFor: 'accessing' stamp: 'cds 6/29/2005 11:36'!
children
	^Array with: component! !

!SCTestBuilder methodsFor: 'initialization' stamp: 'cds 6/29/2005 11:38'!
initialize
	super initialize.
	component := WAMiniCalendar new.
	self session testBuilder: self.! !

!SCTestBuilder methodsFor: 'rendering' stamp: 'mb 7/11/2007 16:27'!
renderContentOn: html 
	html render: component.
	html orderedList
		list: self requests;
		labels: [:request | request url printString , ': ' , request fields printString]! !

!SCTestBuilder methodsFor: 'accessing' stamp: 'cds 6/29/2005 12:02'!
requests
	^requests ifNil: [requests := OrderedCollection new]! !

!SCTestBuilder methodsFor: 'request handling' stamp: 'cds 6/29/2005 12:01'!
submittedRequest: aRequest 
	self requests add: aRequest! !

WAComponent subclass: #SCTestCaseViewer
	instanceVariableNames: 'filterString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestCaseViewer class methodsFor: 'class initialization' stamp: 'cds 11/13/2005 14:51'!
initialize
	"self initialize"
	| app |
	super initialize.
	app := self registerAsApplication: 'testRunner'.
	app preferenceAt: #mainClass put: SCTestCaseMain.
	app preferenceAt: #sessionExpirySeconds put: 6000! !

!SCTestCaseViewer methodsFor: 'accessing' stamp: 'cds 10/30/2005 12:15'!
filterString
	^(filterString isNil or: [filterString isEmpty]) ifTrue: ['*'] ifFalse: [filterString]! !

!SCTestCaseViewer methodsFor: 'accessing' stamp: 'cds 10/30/2005 12:05'!
filterString: anObject
	filterString := anObject! !

!SCTestCaseViewer methodsFor: 'rendering' stamp: 'mb 7/11/2007 17:02'!
renderCase: case on: html 
	^html listItem with:
		[html anchor
			callback: [self runCase: case];
			with: case name]! !

!SCTestCaseViewer methodsFor: 'rendering' stamp: 'mb 7/11/2007 17:06'!
renderContentOn: html 
	| d |
	self renderFilterFormOn: html.
	d := self testCasesByCategory.
	(self sortedCategories
		select: [:category | self filterString match: category])
		do: [:category | 
			html heading
				level: 2;
				with: [html anchor
						callback: [self runCategory: category];
						with: category].
			html orderedList 
				with: [((d at: category)
						asSortedCollection: [:x :y | x name <= y name])
						do: [:case | self renderCase: case on: html]]]! !

!SCTestCaseViewer methodsFor: 'rendering' stamp: 'mb 7/11/2007 17:03'!
renderFilterFormOn: html
	html form with: 
		[html textInput 
			on: #filterString of: self.
		html submitButton
			callback: []; 
			value: 'Filter']! !

!SCTestCaseViewer methodsFor: 'callbacks' stamp: 'cds 10/30/2005 12:16'!
runCase: caseClass
	self call: (SCTestRunner forCase: caseClass suite)! !

!SCTestCaseViewer methodsFor: 'callbacks' stamp: 'mb 8/3/2007 15:31'!
runCategory: categoryString
	| testClasses suite |
	testClasses := self testCasesByCategory at: categoryString.
	suite := SeasidePlatformSupport testSuiteClass new.
	testClasses do: [:each | suite addTest: each suite].
	self call: (SCTestRunner forCase: suite)! !

!SCTestCaseViewer methodsFor: 'accessing' stamp: 'cds 10/30/2005 12:02'!
sortedCategories
	| sc |
	sc := SortedCollection new.
	self testCasesByCategory keys do: [:cat | sc add: cat].
	^sc! !

!SCTestCaseViewer methodsFor: 'accessing' stamp: 'cds 10/30/2005 12:12'!
testCases
	^Preferences testRunnerShowAbstractClasses 
		ifTrue: [SCComponentTestCase allSubclasses]
		ifFalse: [SCComponentTestCase allSubclasses reject: [:cls | cls isAbstract]]! !

!SCTestCaseViewer methodsFor: 'accessing' stamp: 'cds 10/30/2005 11:59'!
testCasesByCategory
	| d |
	d := Dictionary new.
	self testCases do: [:case |
		(d at: case category ifAbsentPut: [OrderedCollection new]) add: case].
	^d! !

WAComponent subclass: #SCTestComponent1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCTestComponent1 class methodsFor: 'seaside' stamp: 'cds 6/19/2004 00:31'!
canBeRoot
	^true! !

!SCTestComponent1 methodsFor: 'rendering' stamp: 'cds 3/23/2007 09:48'!
renderContentOn: html 
	html span
		id: 'main';
		with: 'hello'! !

WAComponent subclass: #SCTestComponent2
	instanceVariableNames: 'firstSent secondSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCTestComponent2 class methodsFor: 'seaside' stamp: 'cds 6/18/2004 21:18'!
canBeRoot
	^true! !

!SCTestComponent2 methodsFor: 'accessing' stamp: 'cds 6/18/2004 14:45'!
firstSent
	^firstSent! !

!SCTestComponent2 methodsFor: 'initialization' stamp: 'mb 7/11/2007 17:06'!
initialize
	super initialize.
	firstSent := false.
	secondSent := false.
! !

!SCTestComponent2 methodsFor: 'accessing' stamp: 'cds 3/23/2007 09:49'!
renderContentOn: html 
	html anchor
		id: 'first';
		callback: [self sendFirst];
		with: 'first link'.
	html text: 'hello'.
	html anchor
		id: 'second';
		callback: [self sendSecond];
		with: 'second link'! !

!SCTestComponent2 methodsFor: 'accessing' stamp: 'cds 6/18/2004 14:45'!
secondSent
	^secondSent! !

!SCTestComponent2 methodsFor: 'callbacks' stamp: 'mb 7/11/2007 17:06'!
sendFirst
	firstSent := true! !

!SCTestComponent2 methodsFor: 'callbacks' stamp: 'mb 7/11/2007 17:06'!
sendSecond
	secondSent := true! !

WAComponent subclass: #SCTestComponent3
	instanceVariableNames: 'field1 field2 button1WasPressed button2WasPressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCTestComponent3 methodsFor: 'callbacks' stamp: 'mb 7/11/2007 17:07'!
button1Pressed
	button1WasPressed := true! !

!SCTestComponent3 methodsFor: 'accessing' stamp: 'cds 6/19/2004 22:46'!
button1WasPressed
	^button1WasPressed! !

!SCTestComponent3 methodsFor: 'callbacks' stamp: 'mb 7/11/2007 17:07'!
button2Pressed
	button2WasPressed := true! !

!SCTestComponent3 methodsFor: 'accessing' stamp: 'cds 6/19/2004 22:46'!
button2WasPressed
	^ button2WasPressed! !

!SCTestComponent3 methodsFor: 'accessing' stamp: 'cds 6/19/2004 22:43'!
field1
	^field1! !

!SCTestComponent3 methodsFor: 'accessing' stamp: 'cds 6/19/2004 22:43'!
field1: anObject
	field1 := anObject! !

!SCTestComponent3 methodsFor: 'accessing' stamp: 'cds 6/19/2004 22:43'!
field2
	^field2! !

!SCTestComponent3 methodsFor: 'accessing' stamp: 'cds 6/19/2004 22:43'!
field2: anObject
	field2 := anObject! !

!SCTestComponent3 methodsFor: 'rendering' stamp: 'cds 3/23/2007 09:51'!
renderContentOn: html 
	html form
		with: [html text: 'field1: '.
			html textInput
				id: 'field1';
				on: #field1 of: self.
			html break.
			html text: 'field2: '.
			html textInput
				id: 'field2';
				on: #field2 of: self.
			html break.
			html submitButton
				id: 'button1';
				callback: [self button1Pressed];
				value: 'button1'.
			html submitButton
				id: 'button2';
				callback: [self button2Pressed];
				value: 'button2']! !

WAComponent subclass: #SCTestComponent4
	instanceVariableNames: 'firstSent secondSent thirdSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCTestComponent4 class methodsFor: 'seaside' stamp: 'cds 7/15/2004 19:51'!
canBeRoot
	^true! !

!SCTestComponent4 methodsFor: 'accessing' stamp: 'cds 7/15/2004 19:51'!
firstSent
	^firstSent! !

!SCTestComponent4 methodsFor: 'initialization' stamp: 'cds 7/13/2007 10:18'!
initialize
	super initialize.
	firstSent := false.
	secondSent := false.
	thirdSent := false! !

!SCTestComponent4 methodsFor: 'accessing' stamp: 'cds 3/23/2007 09:53'!
renderContentOn: html 
	self firstSent
		ifFalse: [html anchor
				callback: [self sendFirst];
				with: 'first link'].
	html text: 'hello'.
	self secondSent
		ifFalse: [
			html anchor
				id: 'second';
				callback: [self sendSecond];
				with: 'second link'].
	self thirdSent
		ifFalse: [
			html anchor
				id: 'third';
				callback: [self sendThird];
				with: 'third link']! !

!SCTestComponent4 methodsFor: 'accessing' stamp: 'cds 7/15/2004 19:51'!
secondSent
	^secondSent! !

!SCTestComponent4 methodsFor: 'callbacks' stamp: 'mb 7/11/2007 17:08'!
sendFirst
	firstSent := true! !

!SCTestComponent4 methodsFor: 'callbacks' stamp: 'mb 7/11/2007 17:08'!
sendSecond
	secondSent := true! !

!SCTestComponent4 methodsFor: 'callbacks' stamp: 'mb 7/11/2007 17:08'!
sendThird
	thirdSent := true.
	self answer: 1234! !

!SCTestComponent4 methodsFor: 'initialization' stamp: 'cds 7/13/2007 10:18'!
states
	^Array with: self! !

!SCTestComponent4 methodsFor: 'accessing' stamp: 'cds 7/15/2004 19:51'!
thirdSent
	^thirdSent! !

WAComponent subclass: #SCTestComponent5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCTestComponent5 methodsFor: 'rendering' stamp: 'cds 3/23/2007 09:53'!
renderContentOn: html 
	html anchor
		callback: [self call: SCTestComponent4 new];
		with: 'Show SCTestComponent4'.
	html anchor
		callback: [self inform: 'this is a dialog'];
		with: 'dialog'! !

WAComponent subclass: #SCTestComponent6
	instanceVariableNames: 'selectedItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCTestComponent6 methodsFor: 'rendering' stamp: 'cds 10/17/2005 13:23'!
itemSelected: item
	selectedItem := item.
	self inform: item printString! !

!SCTestComponent6 methodsFor: 'rendering' stamp: 'cds 3/23/2007 09:57'!
renderContentOn: html
	html form:
		[html select
			id: 'theList';
			list: #(a b c);
			selected: #a;
			callback: [:item | self itemSelected: item].
		html textInput
			callback: [].
		html submitButton
			value: 'submit']! !

!SCTestComponent6 methodsFor: 'accessing' stamp: 'cds 10/17/2005 13:24'!
selectedItem
	^selectedItem! !

WAComponent subclass: #SCTestComponent7
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCTestComponent7 methodsFor: 'rendering' stamp: 'cds 4/14/2006 10:46'!
renderContentOn: html
	html form
		with:
			[html submitButton
				callback: [self answer: true]]! !

WAComponent subclass: #SCTestHistoryView
	instanceVariableNames: 'history currentLocation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestHistoryView class methodsFor: 'instance creation' stamp: 'cds 10/17/2004 20:19'!
forBrowser: aBrowser 
	^ self new history: aBrowser history! !

!SCTestHistoryView methodsFor: 'accessing' stamp: 'mb 7/11/2007 16:36'!
history: h 
	history := h.
	currentLocation := h size! !

!SCTestHistoryView methodsFor: 'initialization' stamp: 'mb 7/11/2007 16:34'!
initialize
	super initialize.
	currentLocation := 1! !

!SCTestHistoryView methodsFor: 'actions' stamp: 'mb 7/11/2007 16:36'!
nextPage
	currentLocation := currentLocation + 1 min: history size! !

!SCTestHistoryView methodsFor: 'utilities' stamp: 'mb 7/11/2007 16:34'!
onlyBodyOf: aString 
	| rs result |
	rs := aString readStream.
	rs upToAll: '<body>'.
	result := rs upToAll: '</body>'.
	^ result! !

!SCTestHistoryView methodsFor: 'actions' stamp: 'mb 7/11/2007 16:36'!
previousPage
	currentLocation := currentLocation - 1 max: 1! !

!SCTestHistoryView methodsFor: 'rendering' stamp: 'cds 7/6/2007 10:10'!
renderContentOn: html 
	html heading level: 2;
		 with: 'Test view replay page ' , currentLocation printString , ' of ' , history size printString.
	html anchor 
		callback: [self answer];
		with: 'close'.
	html space.
	currentLocation > 1
		ifTrue: [html anchor
				callback: [self previousPage];
				with: '<<'].
	html text: '--'.
	currentLocation < history size
		ifTrue: [html anchor
				callback: [self nextPage];
				with: '>>'].
	html break; horizontalRule.
	self renderCurrentResponseOn: html.
! !

!SCTestHistoryView methodsFor: 'rendering' stamp: 'cds 9/10/2007 13:17'!
renderCurrentResponseOn: html 
	| item |
	currentLocation = 0
		ifTrue: [^ nil].
	item := history at: currentLocation.
	html div
		class: 'contentFrame';
		with: [html iframe
				src: (self
						urlForAction: [(SCTestHistoryRenderLoop new page: item value fullStringContents) run]
						on: html)]! !

!SCTestHistoryView methodsFor: 'rendering' stamp: 'mb 7/11/2007 16:35'!
renderRequestOn: html 
	"Doesn't currently work. Not called."
	html heading level: 1; with: 'This page was submitted with: '.
	html break.
	html text: (history at: currentLocation) key stream contents! !

!SCTestHistoryView methodsFor: 'rendering' stamp: 'cds 6/12/2005 19:41'!
style
	^'div.contentFrame {width: 100%; height 500px;}
	*.contentFrame iframe {width: 100%; height: 500px;}'! !

!SCTestHistoryView methodsFor: 'rendering' stamp: 'cds 9/10/2007 13:18'!
urlForAction: aBlock on: html
	"This is missing from our branch of Seaside"
	| url |
	url := html context actionUrl withParameter: (html callbacks registerActionCallback: aBlock).
	^url displayString! !

WAComponent subclass: #SCTestRunner
	instanceVariableNames: 'case result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestRunner class methodsFor: 'seaside plugin' stamp: 'cds 9/24/2006 11:24'!
editorActionsFor: anEntryPoint inEditor: anEditor
	| rootClass |
	(anEntryPoint isKindOf: WAApplication)
		ifFalse: [^#()].
	rootClass := anEntryPoint rootComponent.
	(rootClass isNil or: [rootClass hasTestSuite not])
		ifTrue: [^#()].

	^OrderedCollection new
		add: ((Dictionary new)
				at: #label put: 'test';
				at: #action put: [anEditor call: ((self forCase: rootClass suite) addDecoration: (WAWindowDecoration new title: 'Test runner'); yourself)];
				yourself);
		yourself! !

!SCTestRunner class methodsFor: 'instance creation' stamp: 'cds 7/2/2004 15:20'!
forCase: aTestCase
	^ self new initializeForCase: aTestCase! !

!SCTestRunner class methodsFor: 'seaside plugin' stamp: 'mb 9/25/2007 12:00'!
haloElementsFor: aTarget inHalo: aHalo
	aTarget class hasTestSuite
		ifFalse: [^#()].
	^OrderedCollection new
		add: ((Dictionary new)
				at: #image put: SCTestRunnerFiles / #haloTestGif;
				at: #action put: [self forCase: aTarget class suite];
				at: #title put: 'Run test suite';
				yourself);
		yourself

! !

!SCTestRunner class methodsFor: 'class initialization' stamp: 'acs 7/12/2007 14:35'!
initialize
	"self initialize"
	super initialize.
"	WADispatcherEditor addPlugin: self.
	WAHalo addPlugin: self"! !

!SCTestRunner methodsFor: 'initialization' stamp: 'mb 9/25/2007 12:05'!
initializeForCase: aTestCase 
	case := aTestCase.
	self runTests: case! !

!SCTestRunner methodsFor: 'rendering' stamp: 'cds 7/6/2007 10:09'!
renderBrowserAnchorFor: aTestCase on: html 
	html popupAnchor
		callback: [self call: (WABrowser
							fullOnClass: aTestCase class 
							selector: aTestCase selector)];
		extent: 825@560;
		name: 'browse';
		with: 'Browse'! !

!SCTestRunner methodsFor: 'rendering' stamp: 'cds 7/6/2007 10:07'!
renderContentOn: html 
	html heading level: 2; with: case name.
	html anchor callback: [self runTests: case]; with: 'Re-run all'.
	html break.
	html text: result printString.
	html horizontalRule.
	self renderFailedOn: html.
	self renderErrorOn: html.
	self renderPassedOn: html.
	html break.
	html anchor
		callback: [self answer];
		with: 'close'! !

!SCTestRunner methodsFor: 'rendering' stamp: 'cds 7/6/2007 10:07'!
renderErrorOn: html 
	html heading level: 3; with: 'Errors:'.
	result errors
		do: [:each | 
			html
				span class: 'error-test'; with: [html text: each printString].
			html space.
			html anchor
				callback: [each debug];
				with: 'Debug'.
			html space.
			self renderBrowserAnchorFor: each on: html.
			html space.
			self renderHistoryAnchorFor: each on: html.
			html break].
	html horizontalRule ! !

!SCTestRunner methodsFor: 'rendering' stamp: 'cds 7/6/2007 10:07'!
renderFailedOn: html 
	html heading: 'Failed:' level: 3.
	result failures
		do: [:each | 
			html span class: 'failed-test'; with: each printString.
			html space.
			html anchor
				callback: [each debugAsFailure];
				with: 'Debug'.
			html space.
			self renderBrowserAnchorFor: each on: html.
			html space.
			self renderHistoryAnchorFor: each on: html.
			html break].
	html horizontalRule ! !

!SCTestRunner methodsFor: 'rendering' stamp: 'cds 7/6/2007 10:05'!
renderHistoryAnchorFor: aCase on: html
	html anchor callback: [self viewHistoryFor: aCase]; with: 'History'! !

!SCTestRunner methodsFor: 'rendering' stamp: 'cds 7/6/2007 10:09'!
renderPassedOn: html 
	html heading level: 3; with: 'Passed:'.
	result passed
		do: [:each | 
			html span class: 'passed-test'; with: each printString.
			html space.
			self renderBrowserAnchorFor: each on: html.
			html space.
			self renderHistoryAnchorFor: each on: html.
			html break].
	html horizontalRule! !

!SCTestRunner methodsFor: 'initialization' stamp: 'cds 10/30/2005 12:29'!
runTests: aTestCase 
	result := aTestCase run! !

!SCTestRunner methodsFor: 'actions' stamp: 'cds 6/12/2005 19:43'!
viewHistoryFor: aTestCase 
	self call: (SCTestHistoryView forBrowser: aTestCase browser)! !

Object subclass: #SCBrowserSimulator
	instanceVariableNames: 'history cookies responseSema baseUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 7/17/2004 15:24'!
back
	self history removeLast.
	^ self history last value! !

!SCBrowserSimulator methodsFor: 'private' stamp: 'mb 9/25/2007 23:30'!
cookieString
	| out |
	self cookies isEmpty
		ifTrue: [^ ''].
	out := WriteStream on: String new.
	out nextPutAll: 'Cookie:'.
	self cookies values
		do: [:cookie | out nextPutAll: ' ' , cookie key , '=' , cookie value]
		separatedBy: [out nextPut: $;].
	out nextPutAll: String crlf.
	^ out contents! !

!SCBrowserSimulator methodsFor: 'accessing' stamp: 'mb 9/25/2007 23:30'!
cookies
	^ cookies ifNil: [cookies := Dictionary new]! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 9/24/2006 00:43'!
establishSessionAtBase: baseUrlString 
	| req |
	req := HttpRequest
				readFromStream: (self httpGetRequestStreamFor: baseUrlString).
	baseUrl := baseUrlString.
	^ self issueRequestUntilNotMoved: req! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 9/24/2006 00:41'!
followAnchor: anAnchor 
	| req |
	anAnchor
		ifNil: [self error: 'Anchor cannot be nil'].
	req := HttpRequest
				readFromStream: (self httpGetRequestStreamFor: (self urlForAnchor: anAnchor)).
	^ self issueRequestUntilNotMoved: req! !

!SCBrowserSimulator methodsFor: 'accessing' stamp: 'mb 9/25/2007 23:30'!
history
	^history ifNil: [history := OrderedCollection new]! !

!SCBrowserSimulator methodsFor: 'private' stamp: 'cds 7/17/2004 20:38'!
httpGetRequestStreamFor: url 
	^ ('GET ' , url , ' HTTP/1.0' , String crlf , self cookieString , String crlf) readStream! !

!SCBrowserSimulator methodsFor: 'private' stamp: 'cds 7/17/2004 20:37'!
httpPostRequestStreamForUrl: url data: postData 
	^ ('POST ' , url , ' HTTP/1.0 ' , String crlf , 'Content-Length: ' , postData size printString , String crlf , 'Content-type: application/x-www-form-urlencoded' , String crlf , self cookieString , String crlf , postData) readStream! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 11/16/2007 21:35'!
issueRequestUntilNotMoved: anHttpRequest 
	| response req newUrl doc |
	req := anHttpRequest.
	[response := self privateIssueRequest: req.
	(response status = #tempMoved) or: [response fields includesKey: 'Location']]
		whileTrue: [newUrl := response fields at: 'Location'.
			req := HttpRequest
						readFromStream: (self httpGetRequestStreamFor: newUrl)].
	doc :=  SCSeasideResponseParser parseDocumentFromResponse: response.
	self history add: req -> doc.
	^ doc! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 7/17/2004 15:27'!
lastResponse
	^self history last value! !

!SCBrowserSimulator methodsFor: 'private' stamp: 'mb 9/25/2007 23:32'!
parseCookieString: s 
	| parts keyAndValue result |
	parts := s findTokens: ';'.
	keyAndValue := parts first findTokens: '='.
	result := WACookie key: keyAndValue first value: keyAndValue second.
	^result! !

!SCBrowserSimulator methodsFor: 'private' stamp: 'cds 2/4/2005 08:09'!
privateIssueRequest: anHttpRequest 
	| response cookie |
	response := SeasidePlatformSupport
		issueRequest: anHttpRequest
		responseSemaphore: responseSema.
	response
		ifNil: [^ self error: 'What do I do here?'].
	response cookies
		ifNotNilDo: [:col | col
				do: [:cookieString | 
					cookie := self parseCookieString: cookieString.
					self cookies at: cookie key put: cookie]].
	^ response! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 7/17/2004 15:27'!
refresh
	^ self issueRequestUntilNotMoved: self history last key! !

!SCBrowserSimulator methodsFor: 'accessing' stamp: 'mb 9/25/2007 23:30'!
responseSemaphore: s
	responseSema := s! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 9/24/2006 11:35'!
submitForm: form pressingButton: button 
	| req url |
	form isNil
		ifTrue: [self error: 'form should be nil'].
	url := self urlForForm: form.
	url
		ifNil: [url := self history last key url].
	req := HttpRequest
				readFromStream: (self
						httpPostRequestStreamForUrl: url
						data: (form httpDataWithButton: button)).
	^ self issueRequestUntilNotMoved: req! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 9/24/2006 11:39'!
urlForAnchor: anAnchor 
	^ ((anAnchor asString beginsWith: 'http:')
			or: [anAnchor asString notEmpty and: [anAnchor asString first = $/]])
		ifTrue: [anAnchor asString]
		ifFalse: [baseUrl , anAnchor asString]! !

!SCBrowserSimulator methodsFor: 'request/response' stamp: 'cds 9/24/2006 11:37'!
urlForForm: form 
	^ ((form actionUrl beginsWith: 'http:')
			or: [form actionUrl notEmpty
					and: [form actionUrl first = $/]])
		ifTrue: [form actionUrl]
		ifFalse: [baseUrl , form actionUrl asString]! !

Object subclass: #SCRadioGroup
	instanceVariableNames: 'radioButtons selectedButton name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCRadioGroup class methodsFor: 'instance creation' stamp: 'cds 7/11/2004 02:03'!
named: aString
	^self new name: aString! !

!SCRadioGroup methodsFor: 'accessing' stamp: 'cds 7/11/2004 01:56'!
addButton: aRadioButton
	self radioButtons add: aRadioButton! !

!SCRadioGroup methodsFor: 'accessing' stamp: 'mb 7/11/2007 16:39'!
name: aString
	name := aString! !

!SCRadioGroup methodsFor: 'accessing' stamp: 'mb 7/11/2007 16:39'!
radioButtons
	^radioButtons ifNil: [radioButtons := OrderedCollection new]! !

!SCRadioGroup methodsFor: 'accessing' stamp: 'cds 7/11/2004 02:04'!
selectRadioButton: aButton 
	self radioButtons
		do: [:button | button = aButton
				ifFalse: [button privateMakeUnselected]].
	aButton privateMakeSelected! !

Object subclass: #SCSeasideEntity
	instanceVariableNames: 'attributes entities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

SCSeasideEntity subclass: #SCHtmlInputComponent
	instanceVariableNames: 'form value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

SCHtmlInputComponent subclass: #SCCheckboxHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCCheckboxHtmlInput methodsFor: 'request' stamp: 'cds 7/10/2004 20:08'!
addToRequestStream: aStream 
	self value ifTrue: [aStream nextPutAll: self name].
	^self value! !

!SCCheckboxHtmlInput methodsFor: 'value' stamp: 'cds 7/19/2004 13:33'!
check
	self setValue: true! !

!SCCheckboxHtmlInput methodsFor: 'initialize' stamp: 'mb 7/11/2007 16:38'!
initializeForForm: aForm attributes: theAttributes
	super initializeForForm: aForm attributes: theAttributes.
	value := attributes includes: 'checked'.! !

!SCCheckboxHtmlInput methodsFor: 'testing' stamp: 'cds 7/10/2004 20:06'!
isCheckbox
	^ true! !

!SCCheckboxHtmlInput methodsFor: 'value' stamp: 'cds 7/19/2004 13:33'!
uncheck
	self setValue: false! !

!SCCheckboxHtmlInput methodsFor: 'value' stamp: 'cds 7/19/2004 13:33'!
value: aValue
	aValue
		ifTrue: [self check]
		ifFalse: [self uncheck]! !

SCHtmlInputComponent subclass: #SCFileHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCFileHtmlInput methodsFor: 'request' stamp: 'cds 1/11/2006 08:45'!
addToRequestStream: aStream
	^self value
		ifNil: [false]
		ifNotNil: [super addToRequestStream: aStream]! !

SCHtmlInputComponent subclass: #SCHiddenHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCHtmlInputComponent class methodsFor: 'instance creation' stamp: 'cds 12/17/2005 19:49'!
attributes: attributes form: aForm
	^ self new initializeForForm: aForm attributes: attributes! !

!SCHtmlInputComponent methodsFor: 'request' stamp: 'cds 7/10/2004 18:14'!
addToRequestStream: aStream
	self name ifNil: [^false].
	aStream nextPutAll: self name.
	self value ifNotNil: [aStream nextPut: $=.
		aStream nextPutAll: self value].
	^true! !

!SCHtmlInputComponent methodsFor: 'initialize' stamp: 'mb 9/25/2007 23:33'!
initializeForForm: aForm attributes: theAttributes
	self attributes: theAttributes.
	value := attributes at: 'value' ifAbsent: [].
	form := aForm! !

!SCHtmlInputComponent methodsFor: 'testing' stamp: 'cds 12/17/2005 19:57'!
isInputComponent
	^true! !

!SCHtmlInputComponent methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:52'!
name
	^ self attributeAt: 'name' ifAbsent: []! !

!SCHtmlInputComponent methodsFor: 'private' stamp: 'mb 9/25/2007 23:33'!
setValue: aValue
	value := aValue! !

!SCHtmlInputComponent methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:50'!
tag
	^'input'! !

!SCHtmlInputComponent methodsFor: 'value' stamp: 'cds 7/10/2004 18:09'!
value
	^value! !

!SCHtmlInputComponent methodsFor: 'value' stamp: 'cds 7/19/2004 11:05'!
value: aValue 
	self setValue: aValue! !

SCHtmlInputComponent subclass: #SCRadioButtonHtmlInput
	instanceVariableNames: 'group internalValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCRadioButtonHtmlInput class methodsFor: 'instance creation' stamp: 'cds 12/17/2005 20:17'!
group: aGroup attributes: theAttributes form: aForm
	^self new initializeForGroup: aGroup form: aForm attributes: theAttributes! !

!SCRadioButtonHtmlInput methodsFor: 'request' stamp: 'cds 7/20/2004 15:22'!
addToRequestStream: aStream 
	^ self value
		and: [self name
				ifNil: [false]
				ifNotNil: [aStream nextPutAll: self name.
				aStream nextPut: $=.
				aStream nextPutAll: internalValue.
				true]]! !

!SCRadioButtonHtmlInput methodsFor: 'initialize' stamp: 'mb 7/11/2007 16:38'!
initializeForGroup: aGroup form: aForm attributes: theAttributes
	self initializeForForm: aForm attributes: theAttributes.
	group := aGroup.
	internalValue := value.
	value := attributes includesKey: 'checked'.
	! !

!SCRadioButtonHtmlInput methodsFor: 'testing' stamp: 'cds 7/11/2004 01:57'!
isRadioButton
	^true! !

!SCRadioButtonHtmlInput methodsFor: 'testing' stamp: 'mb 7/11/2007 16:39'!
isSelected
	^ value
		ifNil: [value := false]! !

!SCRadioButtonHtmlInput methodsFor: 'value' stamp: 'cds 7/11/2004 02:04'!
makeSelected
	group selectRadioButton: self! !

!SCRadioButtonHtmlInput methodsFor: 'value' stamp: 'cds 7/19/2004 11:08'!
makeUnselected
	self privateMakeUnselected! !

!SCRadioButtonHtmlInput methodsFor: 'private-value' stamp: 'cds 7/19/2004 11:05'!
privateMakeSelected
	self setValue: true! !

!SCRadioButtonHtmlInput methodsFor: 'private-value' stamp: 'cds 7/19/2004 11:05'!
privateMakeUnselected
	self setValue: false! !

!SCRadioButtonHtmlInput methodsFor: 'value' stamp: 'cds 7/19/2004 11:07'!
value: aValue
	aValue
		ifTrue: [self makeSelected]
		ifFalse: [self makeUnselected]! !

SCHtmlInputComponent subclass: #SCSelectHtmlInput
	instanceVariableNames: 'selectedOptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSelectHtmlInput methodsFor: 'request' stamp: 'cds 10/17/2005 13:27'!
addToRequestStream: aStream 
	self selectedOptions
		do: [:option | option addToRequestStream: aStream] separatedBy: [aStream nextPut: $&].
	^self selectedOptions notEmpty! !

!SCSelectHtmlInput methodsFor: 'testing' stamp: 'cds 7/10/2004 21:34'!
isSelectInput
	^ true! !

!SCSelectHtmlInput methodsFor: 'private-options' stamp: 'mb 7/11/2007 16:50'!
optionSelected: anOption 
	selectedOptions := Array with: anOption
! !

!SCSelectHtmlInput methodsFor: 'private-options' stamp: 'cds 12/17/2005 20:37'!
options
	^self allEntities select: [:each | each isOption]! !

!SCSelectHtmlInput methodsFor: 'value' stamp: 'cds 7/19/2004 13:37'!
selectOptionWithText: text
	self selectOptionWithText: text ifNone: [self error: 'No option labeled ' , text.]! !

!SCSelectHtmlInput methodsFor: 'value' stamp: 'cds 12/17/2005 20:32'!
selectOptionWithText: text ifNone: aBlock 
	| option |
	option := self options detect: [:each | each label = text]
				ifNone: [^aBlock value].
	option select! !

!SCSelectHtmlInput methodsFor: 'private-options' stamp: 'mb 7/11/2007 16:50'!
selectedOptions
	^selectedOptions ifNil: [selectedOptions := OrderedCollection new]! !

!SCSelectHtmlInput methodsFor: 'value' stamp: 'cds 7/19/2004 13:41'!
value: aValue 
	self
		selectOptionWithText: aValue
! !

SCHtmlInputComponent subclass: #SCSubmitButtonHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSubmitButtonHtmlInput methodsFor: 'testing' stamp: 'cds 7/10/2004 16:03'!
isButton
	^true! !

SCHtmlInputComponent subclass: #SCTextHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

SCTextHtmlInput subclass: #SCTextAreaHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCTextHtmlInput methodsFor: 'request' stamp: 'cds 7/10/2004 18:24'!
addToRequestStream: aStream
	^self value
		ifNil: [false]
		ifNotNil: [super addToRequestStream: aStream]! !

!SCTextHtmlInput methodsFor: 'testing' stamp: 'cds 7/10/2004 17:58'!
isTextInput
	^true! !

!SCSeasideEntity methodsFor: 'private' stamp: 'cds 12/17/2005 18:01'!
addEntity: anElement
	self entities add: anElement! !

!SCSeasideEntity methodsFor: 'private' stamp: 'cds 6/20/2004 18:16'!
allElementsIn: element addTo: result 
	result add: element.
	element
		elementsDo: [:subElement | self allElementsIn: subElement addTo: result]! !

!SCSeasideEntity methodsFor: 'private' stamp: 'cds 10/22/2004 13:21'!
allElementsWithTag: tagName in: element addTo: result 
	element name = tagName 
		ifTrue: [result add: element]
		ifFalse: 
			[element elementsDo: 
					[:subElement | 
					self 
						allElementsWithTag: tagName
						in: subElement
						addTo: result]]! !

!SCSeasideEntity methodsFor: 'parts' stamp: 'mb 7/11/2007 16:47'!
allEntities
	| result |
	result := OrderedCollection new.
	result addAll: self entities.
	self entities do: [:entity | entity ifNotNil: [result addAll: entity allEntities]].
	^result! !

!SCSeasideEntity methodsFor: 'anchors' stamp: 'cds 5/25/2006 14:12'!
anchors
	| descendentAnchors |
	descendentAnchors := OrderedCollection new.
	self entities do: [:entity | entity ifNotNil: [descendentAnchors addAll: entity anchors]].
	^self localAnchors , descendentAnchors! !

!SCSeasideEntity methodsFor: 'attributes' stamp: 'cds 12/17/2005 20:21'!
attributeAt: name
	^attributes at: name! !

!SCSeasideEntity methodsFor: 'attributes' stamp: 'cds 12/17/2005 21:52'!
attributeAt: name ifAbsent: aBlock
	^self attributes at: name ifAbsent: aBlock! !

!SCSeasideEntity methodsFor: 'attributes' stamp: 'cds 4/14/2006 11:49'!
attributeAt: name ifPresent: aBlock
	^self attributes at: name ifPresent: aBlock! !

!SCSeasideEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 19:28'!
attributes
	^attributes ifNil: [attributes := Dictionary new]! !

!SCSeasideEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 17:49'!
attributes: anObject
	attributes := anObject! !

!SCSeasideEntity methodsFor: 'buttons' stamp: 'cds 9/10/2007 13:59'!
buttonWithValue: aString 
	^ self buttons
		detect: [:each | each value = aString] 
		ifNone: [self error: 'no such button']! !

!SCSeasideEntity methodsFor: 'buttons' stamp: 'cds 5/25/2006 14:13'!
buttons
	^self allEntities select: [:each | each notNil and: [each isInputComponent and: [each isButton]]]! !

!SCSeasideEntity methodsFor: 'contents' stamp: 'cds 12/17/2005 21:18'!
containsString: aString 
	"Look deep into the containment hierarchy looking for the specified string"
	(self contentString includesSubString: aString) ifTrue: [^true].
	^self entities anySatisfy: [:each | each containsString: aString]! !

!SCSeasideEntity methodsFor: 'contents' stamp: 'cds 12/17/2005 19:35'!
contentString
	| result |
	result := WriteStream on: String new.
	(self entities select: [:each | each isTextEntity]) do: [:textEntity |
		result nextPutAll: textEntity text].
	^result contents! !

!SCSeasideEntity methodsFor: 'attributes' stamp: 'cds 12/18/2005 17:38'!
cssClass
	^self attributeAt: 'class' ifAbsent: []! !

!SCSeasideEntity methodsFor: 'attributes' stamp: 'cds 12/17/2005 21:41'!
cssId
	^self attributeAt: 'id' ifAbsent: []! !

!SCSeasideEntity methodsFor: 'contents' stamp: 'cds 12/17/2005 18:00'!
entities
	^entities ifNil: [entities := OrderedCollection new]! !

!SCSeasideEntity methodsFor: 'parts' stamp: 'cds 12/17/2005 18:50'!
entitiesNamed: aStringTagName 
	^self allEntities select: [:each | each tag = aStringTagName]! !

!SCSeasideEntity methodsFor: 'parts' stamp: 'cds 4/14/2006 11:50'!
entitiesWithClass: aString 
	^self allEntities
		select: [:each | ((each attributeAt: 'class' ifAbsent: ['']) findTokens: ' ') includes: aString]! !

!SCSeasideEntity methodsFor: 'parts' stamp: 'cds 12/17/2005 20:11'!
entityWithId: aString 
	^self entityWithId: aString ifAbsent: [self error: 'No such element.']! !

!SCSeasideEntity methodsFor: 'contents' stamp: 'cds 12/17/2005 21:15'!
entityWithId: id containsText: aString 
	^(self entityWithId: id) containsString: aString! !

!SCSeasideEntity methodsFor: 'parts' stamp: 'cds 12/17/2005 20:11'!
entityWithId: aString ifAbsent: aBlock 
	^self allEntities detect: [:each | each cssId = aString] ifNone: aBlock! !

!SCSeasideEntity methodsFor: 'forms' stamp: 'cds 5/25/2006 14:12'!
forms
	| descendentForms |
	descendentForms := OrderedCollection new.
	self entities do: [:entity | entity ifNotNil: [descendentForms addAll: entity forms]].
	^self localForms , descendentForms! !

!SCSeasideEntity methodsFor: 'inputs' stamp: 'cds 5/25/2006 14:13'!
inputs
	^self allEntities select: [:each | each notNil and: [each isInputComponent]]! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 12/17/2005 19:27'!
isAnchor
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 1/10/2006 08:54'!
isButton
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 1/10/2006 08:54'!
isCheckbox
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 1/10/2006 08:54'!
isInputComponent
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 12/17/2005 20:33'!
isOption
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 1/10/2006 08:54'!
isRadioButton
	^ false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 12/17/2005 19:43'!
isSeasideForm
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 1/10/2006 08:54'!
isSelectInput
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 12/17/2005 19:35'!
isTextEntity
	^false! !

!SCSeasideEntity methodsFor: 'testing' stamp: 'cds 1/10/2006 08:53'!
isTextInput
	^false! !

!SCSeasideEntity methodsFor: 'anchors' stamp: 'cds 5/25/2006 14:12'!
localAnchors
	^self entities select: [ :each | each notNil and: [each isAnchor]]! !

!SCSeasideEntity methodsFor: 'forms' stamp: 'cds 5/25/2006 14:13'!
localForms
	^self entities select: [:each | each notNil and: [each isSeasideForm]]! !

!SCSeasideEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:48'!
tag
	"Return a lower case HTML tag describing this entity"
	self subclassResponsibility! !

SCSeasideEntity subclass: #SCSeasideForm
	instanceVariableNames: 'radioGroups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSeasideForm class methodsFor: 'instance creation' stamp: 'cds 12/17/2005 19:33'!
withAttributes: attributes
	^self new attributes: attributes; yourself! !

!SCSeasideForm methodsFor: 'posting' stamp: 'cds 12/17/2005 20:22'!
actionUrl
	^ self attributeAt: 'action'! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 7/10/2004 17:38'!
activateCheckboxWithId: stringId 
	self checkboxWithId: stringId value: true! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 7/16/2004 12:17'!
activateRadioButtonWithId: stringId 
	(self radioButtonWithId: stringId) makeSelected! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'mb 7/11/2007 16:48'!
checkboxWithId: stringId
	| input |
	input := self
				inputWithId: stringId
				ifAbsent: [self error: 'No such input component.'].
	input isCheckbox
		ifFalse: [self error: 'Not a checkbox component.'].
	^input! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 7/16/2004 12:16'!
checkboxWithId: stringId value: aBoolean 
	(self checkboxWithId: stringId) value: aBoolean! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 7/10/2004 17:38'!
deactivateCheckboxWithId: stringId 
	self checkboxWithId: stringId value: false! !

!SCSeasideForm methodsFor: 'private-inputs' stamp: 'cds 7/11/2004 02:03'!
getOrCreateRadioGroup: groupName
	^self radioGroups at: groupName ifAbsentPut: [SCRadioGroup named: groupName].! !

!SCSeasideForm methodsFor: 'posting' stamp: 'cds 12/20/2005 12:08'!
httpDataWithButton: button 
	| resultStream nonButtonInputs |
	resultStream := WriteStream on: String new.
	button ifNotNil: [((button addToRequestStream: resultStream) and: [self inputs notEmpty]) 
		ifTrue: [resultStream nextPut: $&]].
	nonButtonInputs := self inputs reject: [:each | each isButton].
	nonButtonInputs allButLast do: 
			[:each | 
			(each addToRequestStream: resultStream) ifTrue: [resultStream nextPut: $&]].
	nonButtonInputs last addToRequestStream: resultStream.
	^resultStream contents! !

!SCSeasideForm methodsFor: 'private-inputs' stamp: 'cds 12/17/2005 20:11'!
inputWithId: anId ifAbsent: aBlock
	| res |
	res := self entityWithId: anId ifAbsent: [^aBlock value].
	^res isInputComponent 
		ifTrue: [res]
		ifFalse: [aBlock value]! !

!SCSeasideForm methodsFor: 'private-inputs' stamp: 'cds 12/18/2005 17:37'!
inputWithName: aName ifAbsent: aBlock 
	self inputs detect: [:each | each name = aName] ifNone: aBlock! !

!SCSeasideForm methodsFor: 'private-inputs' stamp: 'cds 12/18/2005 17:39'!
inputsWithClass: aName
	^self inputs select: [:each | each cssClass = aName]! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 9/9/2007 13:03'!
inputsWithLabel: aString
	| labels |
	labels := self labelsWithText: aString.
	^labels collect: [:label | 
		self
				inputWithId: (label attributeAt: 'for')
				ifAbsent: [self error: 'No such input component.']].
! !

!SCSeasideForm methodsFor: 'testing' stamp: 'cds 12/17/2005 19:43'!
isSeasideForm
	^true! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 9/9/2007 13:05'!
labelsWithText: aString
	| labels |
	labels := self entitiesNamed: 'label'.
	^labels select: [:each | each contentString = aString].
! !

!SCSeasideForm methodsFor: 'private-inputs' stamp: 'cds 1/31/2005 14:13'!
optionValuesByTextForSelect: aSelectElement 
	| optionElements result |
	optionElements := aSelectElement elements
				select: [:each | each name = 'option'].
	result := Dictionary new.
	optionElements
		do: [:each | result at: (each contents first string) put: (each attributeAt: 'value') ].
	^result! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'mb 7/11/2007 16:48'!
radioButtonWithId: stringId 
	| input |
	input := self
				inputWithId: stringId
				ifAbsent: [self error: 'No such input component.'].
	input isRadioButton
		ifFalse: [self error: 'Not a radio button component.'].
	^input! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'mb 7/11/2007 16:48'!
radioGroups
	^radioGroups ifNil: [radioGroups := Dictionary new]! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'mb 7/11/2007 16:49'!
selectListWithId: aStringId
	| elem |
	elem := self
				inputWithId: aStringId
				ifAbsent: [self error: 'No such input field.'].
	elem isSelectInput
		ifFalse: [self error: 'Not a select'].
	^ elem! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 7/16/2004 12:15'!
selectListWithId: aStringId selectOptionWithText: text 
	(self selectListWithId: aStringId) selectOptionWithText: text ifNone: [self error: 'No such option.']! !

!SCSeasideForm methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:46'!
tag
	^'form'! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'mb 7/11/2007 16:49'!
textInputWithId: stringId
	| input |
	input := self
				inputWithId: stringId
				ifAbsent: [self error: 'No such input component.'].
	input isTextInput
		ifFalse: [self error: 'Not a text component.'].
	^input! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 7/16/2004 12:13'!
textInputWithId: stringId value: stringValue 
	(self textInputWithId: stringId) value: stringValue! !

!SCSeasideForm methodsFor: 'inputs' stamp: 'cds 8/31/2006 15:25'!
textInputs
	^self allEntities select: [:each | each isTextInput]! !

!SCSeasideForm methodsFor: 'posting' stamp: 'mb 9/25/2007 23:34'!
writeHttpDataFor: key value: value on: stream 
	| name |
	name := key.
	value
		ifNil: [^ stream nextPutAll: name].
	value isString
		ifTrue: [stream nextPutAll: name;
				 nextPut: $=;
				 nextPutAll: value]
		ifFalse: [value
				do: [:each | self
						writeHttpDataFor: key
						value: each
						on: stream]
				separatedBy: [stream nextPut: $&]]! !

SCSeasideEntity subclass: #SCSeasideGenericEntity
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSeasideGenericEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:48'!
tag
	^tag asLowercase! !

!SCSeasideGenericEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:47'!
tag: anObject
	tag := anObject! !

SCSeasideEntity subclass: #SCSeasideResponse
	instanceVariableNames: 'httpResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 6/19/2004 21:55'!
anchorWithId: aString 
	^self
		anchorWithId: aString
		ifNone: []! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 12/17/2005 20:11'!
anchorWithId: aString ifNone: aBlock 
	^self entityWithId: aString ifAbsent: aBlock! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 6/23/2004 14:05'!
anchorWithLabel: aString 
	^ self anchors detect: [:anchor | anchor label = aString] ifNone: []! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 7/18/2004 00:55'!
anchorWithLabel: aString ifNone: aBlock
	^ self anchors
		detect: [:anchor | anchor label = aString]
		ifNone: aBlock! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 12/17/2005 22:00'!
anchorsIncludingString: aString 
	^self anchors select: [:anchor | anchor containsString: aString]
! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 11/10/2005 20:45'!
anchorsWithClass: aString
	^ self anchors
		select: [:anchor | anchor cssClass = aString]! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 9/5/2004 23:00'!
anchorsWithLabel: aString 
	^ self anchors
		select: [:anchor | anchor label = aString]! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 12/17/2005 20:42'!
bodyElement
	^self entities first entities detect: [:each | each tag asUppercase = 'BODY']! !

!SCSeasideResponse methodsFor: 'HTTP info' stamp: 'cds 6/25/2007 16:30'!
contents
	^self httpResponse contents contents! !

!SCSeasideResponse methodsFor: 'HTTP info' stamp: 'cds 7/16/2004 15:12'!
cookies
	^httpResponse cookies! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 6/19/2004 23:05'!
formWithId: aString 
	^ self formWithId: aString ifNone: []! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 12/17/2005 20:11'!
formWithId: aString ifNone: aBlock 
	^self entityWithId: aString ifAbsent: aBlock! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 7/20/2004 14:48'!
fullStringContents
	^httpResponse contents contents! !

!SCSeasideResponse methodsFor: 'HTTP info' stamp: 'cds 6/25/2007 16:29'!
httpResponse
	^httpResponse! !

!SCSeasideResponse methodsFor: 'private' stamp: 'cds 12/17/2005 21:39'!
httpResponse: anObject
	httpResponse := anObject! !

!SCSeasideResponse methodsFor: 'HTTP info' stamp: 'cds 7/16/2004 15:10'!
status
	^httpResponse status! !

!SCSeasideResponse methodsFor: 'parts' stamp: 'cds 12/17/2005 20:25'!
stringWithId: anId 
	^(self entityWithId: anId) contentString! !

SCSeasideEntity subclass: #SCSeasideStateMarker
	instanceVariableNames: 'sessionId continuationId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

SCSeasideStateMarker subclass: #SCSeasideAnchor
	instanceVariableNames: 'fullUrl anchorNumber path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSeasideAnchor class methodsFor: 'instance creation' stamp: 'cds 12/17/2005 18:03'!
withAttributes: attributes
	^self new initializeFromHref: (attributes at: 'href'); attributes: attributes; yourself! !

!SCSeasideAnchor methodsFor: 'accessing' stamp: 'cds 6/18/2004 14:19'!
anchorNumber
	^anchorNumber! !

!SCSeasideAnchor methodsFor: 'accessing' stamp: 'cds 6/18/2004 14:19'!
anchorNumber: anObject
	anchorNumber := anObject! !

!SCSeasideAnchor methodsFor: 'converting' stamp: 'cds 6/19/2004 19:52'!
asString
	^ fullUrl! !

!SCSeasideAnchor methodsFor: 'accessing' stamp: 'mb 11/13/2006 17:19'!
basePath: aString 
	(fullUrl findTokens: '/') first = fullUrl 
		ifTrue: [fullUrl := aString , fullUrl]! !

!SCSeasideAnchor methodsFor: 'accessing' stamp: 'mb 7/11/2007 16:40'!
fullUrl: aString
	fullUrl := aString! !

!SCSeasideAnchor methodsFor: 'initialize' stamp: 'mb 7/23/2007 16:22'!
initializeFromHref: aString 
	| parts |
	self fullUrl: aString.
	parts := aString findTokens: '?'.
	parts isEmpty
		ifTrue: [^ self].
	aString first == $? ifTrue: [parts addFirst: String new].
	self path: parts first.
	parts size > 1
		ifTrue: [(parts second findTokens: '&')
				do: [:each | self variableFromString: each]]! !

!SCSeasideAnchor methodsFor: 'testing' stamp: 'cds 12/17/2005 19:28'!
isAnchor
	^true! !

!SCSeasideAnchor methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:24'!
label
	^self contentString! !

!SCSeasideAnchor methodsFor: 'accessing' stamp: 'mb 7/11/2007 16:40'!
path: aString
	path := aString! !

!SCSeasideAnchor methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:47'!
tag
	^'a'! !

!SCSeasideAnchor methodsFor: 'initialize' stamp: 'mb 9/25/2007 23:35'!
variableFromString: aString 
	| parts |
	parts := aString findTokens: '='.
	parts isEmpty
		ifTrue: [^ nil].
	parts size = 1
		ifTrue: [^ self anchorNumber: parts first].	
	parts first = '_s' "WARegistry>>handlerField"
		ifTrue: [^ self sessionId: parts second].
	parts first = '_k' "WASession>>actionField"
		ifTrue: [^ self continuationId: parts second]! !

!SCSeasideStateMarker methodsFor: 'accessing' stamp: 'cds 6/18/2004 13:23'!
continuationId
	^continuationId! !

!SCSeasideStateMarker methodsFor: 'accessing' stamp: 'cds 6/18/2004 13:23'!
continuationId: anObject
	continuationId := anObject! !

!SCSeasideStateMarker methodsFor: 'accessing' stamp: 'cds 6/18/2004 13:23'!
sessionId
	^sessionId! !

!SCSeasideStateMarker methodsFor: 'accessing' stamp: 'cds 6/18/2004 13:23'!
sessionId: anObject
	sessionId := anObject! !

SCSeasideEntity subclass: #SCSeasideTextEntity
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSeasideTextEntity commentStamp: '<historical>' prior: 0!
Not a real XHTML element...just a place to hold CDATA.!

!SCSeasideTextEntity class methodsFor: 'instance creation' stamp: 'cds 12/17/2005 17:50'!
on: aString
	^self new text: aString! !

!SCSeasideTextEntity methodsFor: 'testing' stamp: 'cds 12/17/2005 19:36'!
isTextEntity
	^true! !

!SCSeasideTextEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:48'!
tag
	^'none'! !

!SCSeasideTextEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 17:50'!
text
	^text! !

!SCSeasideTextEntity methodsFor: 'accessing' stamp: 'cds 12/17/2005 17:50'!
text: anObject
	text := anObject! !

SCSeasideEntity subclass: #SCSelectOption
	instanceVariableNames: 'label value selectInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Html Entities'!

!SCSelectOption class methodsFor: 'instance creation' stamp: 'cds 12/17/2005 20:29'!
select: aSelect attributes: attributes
	^ self new initializeForSelect: aSelect attributes: attributes! !

!SCSelectOption methodsFor: 'request' stamp: 'cds 7/11/2004 01:17'!
addToRequestStream: aStream 
	aStream nextPutAll: selectInput name;
		 nextPut: $=;
		 nextPutAll: value.
	^ true! !

!SCSelectOption methodsFor: 'initialize' stamp: 'mb 7/13/2007 18:53'!
initializeForSelect: aSelect attributes: theAttributes 
	self attributes: theAttributes.
	value := attributes at: 'value' ifAbsent: [nil].
	selectInput := aSelect.
	(attributes includesKey: 'selected')
		ifTrue: [selectInput selectedOptions add: self]! !

!SCSelectOption methodsFor: 'testing' stamp: 'cds 12/17/2005 20:33'!
isOption
	^true! !

!SCSelectOption methodsFor: 'accessing' stamp: 'cds 12/17/2005 20:37'!
label
	^self contentString! !

!SCSelectOption methodsFor: 'processing' stamp: 'cds 7/10/2004 22:27'!
select
	selectInput optionSelected: self! !

!SCSelectOption methodsFor: 'testing' stamp: 'cds 12/17/2005 20:48'!
tag
	^'select'! !

Object subclass: #SCTestHistoryContentView
	instanceVariableNames: 'page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestHistoryContentView methodsFor: 'accessing' stamp: 'cds 9/23/2006 15:54'!
page
	^page! !

!SCTestHistoryContentView methodsFor: 'accessing' stamp: 'cds 9/23/2006 15:54'!
page: anObject
	page := anObject! !

Object subclass: #SCTestHistoryRenderLoop
	instanceVariableNames: 'page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestHistoryRenderLoop methodsFor: 'accessing' stamp: 'cds 6/12/2005 13:20'!
page
	^page! !

!SCTestHistoryRenderLoop methodsFor: 'accessing' stamp: 'cds 6/12/2005 13:20'!
page: anObject
	page := anObject! !

!SCTestHistoryRenderLoop methodsFor: 'rendering' stamp: 'cds 9/23/2006 21:54'!
render
	| response |
	WACurrentSession value
		respond: [:url | 
			response := WAResponse new.
			response headerAt: 'Cache-Control' put: 'No-cache'.
			response stream nextPutAll: page.
			response]! !

!SCTestHistoryRenderLoop methodsFor: 'rendering' stamp: 'cds 9/23/2006 21:57'!
run
	[self render] repeat! !

WAInputElementContainer subclass: #SCInputElementContainer
	instanceVariableNames: 'numericInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCInputElementContainer methodsFor: 'initialization' stamp: 'mb 10/12/2007 00:17'!
initialize
	super initialize.
	numericInput := 42! !

!SCInputElementContainer methodsFor: 'accessing' stamp: 'mb 10/12/2007 00:16'!
numericInput
	"This accessor is needed by David's SeasideTesting package'"
	^ numericInput
! !

!SCInputElementContainer methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:17'!
renderContentOn: html 
	self renderHeadingOn: html.
	self renderTextInputOn: html.
	self renderNumericInputOn: html.
	self renderTextInputExampleOn: html.
	self renderTextAreaOn: html.
	self renderTextAreaExampleOn: html.
	self renderSingleSelectionOn: html.
	self renderSingleSelectionOptionalOn: html.
	self renderSingleSelectionWithoutCallbackOn: html.
	self renderMultiSelectionOn: html.
	self renderNestedSelectionOn: html
! !

!SCInputElementContainer methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:18'!
renderNumericInputOn: html 
	self
		renderLabel: 'Numeric Input'
		input: [html textInput id: 'numeric-input';
				 setFocus;
				 value: numericInput;
				
				callback: [:value | numericInput := value asInteger]]
		output: numericInput printString
		on: html
! !

WAInputTest subclass: #SCInputTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCInputTest methodsFor: 'initialization' stamp: 'mb 10/12/2007 00:15'!
initialize
	super initialize.
	inputElements := SCInputElementContainer new! !

!SCInputTest methodsFor: 'accessing' stamp: 'mb 10/12/2007 00:10'!
label
	^ 'SCInput'! !

!SCInputTest methodsFor: 'accessing' stamp: 'mb 10/12/2007 00:13'!
numericInput
	^ inputElements numericInput! !

!HttpRequest methodsFor: '*SeasideTesting-squeak' stamp: 'mb 11/13/2006 17:28'!
initRemoteAddress
	(stream respondsTo: #socket) ifTrue:
		[self remoteAddress: stream socket remoteAddress]! !

Error subclass: #SCTestException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

WAApplication subclass: #SCTesterApplication
	instanceVariableNames: 'testCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCTesterApplication commentStamp: '<historical>' prior: 0!
Components under test use instances of SCTesterApplication for their application class.  This needed to:

1) expose handlerWithKey:
2) provide the test case with the opportunity to interfere with session creation.!

!SCTesterApplication class methodsFor: 'testing' stamp: 'cds 6/12/2005 12:28'!
isAbstract
	^true! !

!SCTesterApplication class methodsFor: 'accessing' stamp: 'cds 3/23/2007 09:25'!
path: aString
	^self named: aString! !

!SCTesterApplication methodsFor: 'request handling' stamp: 'cds 3/23/2007 09:37'!
createSession
	| session |
	session := self sessionClass new setParent: self.
	testCase sessionCreated: session.
	^session! !

!SCTesterApplication methodsFor: 'accessing' stamp: 'acs 7/13/2007 10:16'!
description
^'Seaside testing'! !

!SCTesterApplication methodsFor: 'request handling' stamp: 'cds 3/19/2006 11:56'!
handleDefaultRequest: aRequest 
	| session |
	session := self createSession.
	^session handleRequest: aRequest! !

!SCTesterApplication methodsFor: 'accessing' stamp: 'cds 6/18/2004 20:46'!
handlerWithKey: aKey
	^handlersByKey at: aKey ifAbsent: []! !

!SCTesterApplication methodsFor: 'accessing' stamp: 'cds 3/19/2006 12:10'!
testCase
	^testCase! !

!SCTesterApplication methodsFor: 'accessing' stamp: 'cds 3/19/2006 12:10'!
testCase: anObject
	testCase := anObject! !

WAHtmlTest subclass: #SCHtmlTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCHtmlTest methodsFor: 'accessing' stamp: 'mb 10/12/2007 00:22'!
booleanList
	^ booleanList! !

!SCHtmlTest methodsFor: 'accessing' stamp: 'mb 10/12/2007 00:20'!
label
	^ 'SCForm Elements'! !

!SCHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:24'!
renderCheckboxesOn: html
	"same method as in superclass except for id= attributes"
	html text: booleanList.
	html paragraph.
	html form
		id: 'checkbox-form';
		with:
			[booleanList
				do: [:association | 
					html text: association key;
						space.
					html checkbox
						id: 'cb-' , association key;
						addShortcut: 'Ctrl-' , association key asUppercase;
						on: #value of: association.
					html span
						class: 'indented';
						class: 'hint';
						with: 'Shortcuts: ' , 'Ctrl-' , association key asUppercase.
					html break].
			html submitButton]! !

!SCHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:30'!
renderContentOn: html
	super renderContentOn: html! !

!SCHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:25'!
renderRadioButtonsOn: html
	"same method as in superclass except for id= attributes"
	html text: booleanList.
	html paragraph.
	html form
		id: 'radio-form';
		with: 
			[booleanList do: [ :association |
				| group |
				group := html radioGroup.
				html text: association key; space.
				group radioButton
					id: association key , '-on';
					addShortcut: 'Ctrl-' , association key;
					selected: association value;
					callback: [ association value: true ].
				group radioButton
					id: association key , '-off';
					addShortcut: 'Alt-' , association key;
					selected: association value not;
					callback: [ association value: false ].
				html span
					class: 'indented';
					class: 'hint';
					with: 'Shortcuts: ' , 'Ctrl-' , association key , ' Alt-' , association key.
				html break ].
			html submitButton ]! !

!SCHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:25'!
renderSelectsOn: html
	"same method as in superclass except for id= attributes"
	html text: number.
	html paragraph.
	html form
		id: 'select-form';
		with: 
			[html
				select id: 'select-list';
				list: (1 to: 10);
				on: #number of: self.
			html submitButton]! !

!SCHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:26'!
renderSubmitButtonsOn: html 
	"same method as in superclass except for id= attributes"
	html text: number.
	html paragraph.
	html form 
		id: 'button-form';
		with: 
			[1 to: 10 do: 
				[:index | 
				html submitButton
						addShortcut: 'F' , index displayString;
						callback: [number := index];
						text: index.
				html space]].
	html span
		class: 'hint';
		with: 'Above, you may be able to use F1 .. F10 as shortcuts, if the browser allows you.'! !

!SCHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:26'!
renderTextAreaOn: html 
	"same method as in superclass except for id= attributes"
	| position |
	position := message = self initialMessage
				ifTrue: [6]
				ifFalse: ['End'].
	html form
		id: 'textarea-form';
		with:
			[html span
				id: 'textarea-banner'; 
				with: message.
			html paragraph 
				class: 'hint';
				with: 'The text area below should have the focus and be wholly selected, unless it has its initial value, '
					, self initialMessage printString 
					, ', in which case you should see the cursor right after the "o" of "Hello".'.
			html textArea
				id: 'textarea-message';
				setCursorPosition: position;
				on: #message of: self.
			html break.
			html submitButton]! !

!SCHtmlTest methodsFor: 'rendering' stamp: 'mb 10/12/2007 00:27'!
renderTextInputOn: html 
	"same method as in superclass except for id= attributes"
	html form
		id:  'textInput-form'; 
		with: 
			[html span
					id: 'textInput-banner';
					with: message.
			html paragraph.
			html textInput
					id: 'text-message';
					on: #message of: self.
			html submitButton]! !

SAXHandler subclass: #SCSeasideResponseParser
	instanceVariableNames: 'stack response currentForm currentSelect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCSeasideResponseParser class methodsFor: 'private' stamp: 'cds 7/1/2006 13:28'!
addEntitiesTo: aDict
	aDict at: 'nbsp' put: (DTDEntityDeclaration name: 'nbsp' value: Character space)! !

!SCSeasideResponseParser class methodsFor: 'parsing' stamp: 'cds 7/20/2007 16:01'!
parseDocumentFrom: aStream
	^SeasidePlatformSupport parseSeasideDocumentFrom: aStream! !

!SCSeasideResponseParser class methodsFor: 'parsing' stamp: 'cds 6/25/2007 16:28'!
parseDocumentFromResponse: aResponse
	^((aResponse contentType beginsWith: 'text/html') or: [aResponse contentType beginsWith: 'text/xhtml']) ifTrue: [
	(self parseDocumentFrom: aResponse contents) httpResponse: aResponse; yourself]
	ifFalse: [SCSeasideResponse new httpResponse: aResponse; yourself]! !

!SCSeasideResponseParser methodsFor: 'stack' stamp: 'cds 12/17/2005 17:59'!
addEntity: entity
	self stack notEmpty ifTrue: [self top addEntity: entity].
	self push: entity! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 17:57'!
characters: aString
	self top addEntity: (SCSeasideTextEntity on: aString)! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 20:28'!
endElement: elementName
	elementName asUppercase = 'FORM' ifTrue: [currentForm := nil].
	elementName asUppercase = 'SELECT' ifTrue: [currentSelect := nil].
	^self pop! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 17:35'!
ignorableWhitespace: aString
	self characters: aString first asString! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 4/14/2006 12:27'!
inputComponentFor: attributes 
	| type |
	type := (attributes
				at: 'type'
				ifAbsent: ['']) asLowercase.
	type = 'text' | (type = 'password')
		ifTrue: [^ SCTextHtmlInput attributes: attributes form: currentForm].
	type = 'checkbox'
		ifTrue: [^ SCCheckboxHtmlInput attributes: attributes form: currentForm].
	type = 'hidden'
		ifTrue: [^ SCHiddenHtmlInput attributes: attributes form: currentForm].
	type = 'submit'
		ifTrue: [^ SCSubmitButtonHtmlInput attributes: attributes form: currentForm].
	type = 'radio'
		ifTrue: [^ self radioComponentFor: attributes].
	type = 'reset'
		ifTrue: [^ nil].
	type = 'file'
		ifTrue: [^ SCFileHtmlInput attributes: attributes form: currentForm].
	self error: 'unknown input type'! !

!SCSeasideResponseParser methodsFor: 'stack' stamp: 'cds 12/17/2005 16:42'!
pop
	^self stack removeLast! !

!SCSeasideResponseParser methodsFor: 'stack' stamp: 'cds 12/17/2005 16:42'!
push: anObject 
	self stack add: anObject! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'mb 9/25/2007 23:36'!
radioComponentFor: attributes
	| group button |
	group := currentForm
				getOrCreateRadioGroup: (attributes at: 'name' ifAbsent: []).
	button := SCRadioButtonHtmlInput group: group attributes: attributes form: currentForm.
	group addButton: button.
	^ button! !

!SCSeasideResponseParser methodsFor: 'accessing' stamp: 'cds 12/17/2005 16:47'!
response
	^response! !

!SCSeasideResponseParser methodsFor: 'accessing' stamp: 'cds 12/17/2005 16:47'!
response: anObject
	response := anObject! !

!SCSeasideResponseParser methodsFor: 'stack' stamp: 'cds 12/17/2005 16:42'!
stack
	^stack ifNil: [stack := OrderedCollection new]! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 9/24/2006 00:43'!
startAnchor: attributes 
	| anchor |
	anchor := SCSeasideAnchor withAttributes: attributes.
	self addEntity: anchor! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 18:05'!
startDocument
	self push: self document! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 3/23/2007 09:58'!
startElement: elementName attributeList: attributeList 
	| tag |
	tag := elementName asUppercase.
	tag = 'A'
		ifTrue: [^self startAnchor: attributeList].
	tag = 'FORM'
		ifTrue: [^self startForm: attributeList].
	tag = 'INPUT'
		ifTrue: [^self startInput: attributeList].
	tag = 'BUTTON'
		ifTrue: [^self startInput: attributeList].
	tag = 'SELECT'
		ifTrue: [^self startSelect: attributeList].
	tag = 'TEXTAREA'
		ifTrue: [^self startTextArea: attributeList].
	tag = 'OPTION'
		ifTrue: [^self startOption: attributeList].
	^self startGenericElement: elementName attributeList: attributeList! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 17:35'!
startElement: localName namespaceURI: namespaceUri namespace: namespace attributeList: attributeList 
	^ self startElement: localName attributeList: attributeList! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 19:47'!
startForm: attributes
	| form |
	form := SCSeasideForm withAttributes: attributes.
	self addEntity: form.
	currentForm := form! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 17:57'!
startGenericElement: elementName attributeList: attributeList 
	| entity |
	entity := SCSeasideGenericEntity new tag: elementName;
				 attributes: attributeList.
	self addEntity: entity! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 20:20'!
startInput: attributes
	self addEntity: (self inputComponentFor: attributes)! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 20:29'!
startOption: attributes
	self addEntity: (SCSelectOption select: currentSelect attributes: attributes)
! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 20:27'!
startSelect: attributes
	self addEntity: (currentSelect := SCSelectHtmlInput attributes: attributes form: currentForm).! !

!SCSeasideResponseParser methodsFor: 'content' stamp: 'cds 12/17/2005 19:51'!
startTextArea: attributes
	self addEntity: (SCTextAreaHtmlInput attributes: attributes form: currentForm).! !

!SCSeasideResponseParser methodsFor: 'stack' stamp: 'cds 12/17/2005 16:42'!
top
	^self stack last! !

SeasideAddonVWInfo subclass: #SeasideTestingVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Platform'!

!SeasideTestingVWInfo class methodsFor: 'accessing' stamp: 'mb 7/11/2007 17:14'!
addonName
	^ 'SeasideTesting'! !

!SeasideTestingVWInfo methodsFor: 'listing' stamp: 'mb 7/11/2007 17:19'!
extensionMethods
	^ super extensionMethods
		reject:
			[:methodRef | 
			self ignoredExternalClasses includes: methodRef actualClass]! !

!SeasideTestingVWInfo methodsFor: 'accessing' stamp: 'cds 2/4/2005 08:10'!
ignoredExternalClasses
	^{HttpRequest. XMLTokenizer. SeasidePlatformSupport class}! !

WAFileLibrary subclass: #SCTestRunnerFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestRunnerFiles methodsFor: 'uploaded' stamp: 'mb 7/12/2007 11:39'!
haloTestGif
	| xxxCache |
	xxxCache := #(nil ) beMutable.
	(xxxCache at: 1) isNil
		ifTrue: [xxxCache at: 1 put: #(71 73 70 56 57 97 16 0 16 0 240 0 49 63 63 63 212 212 212 33 249 4 1 0 0 1 0 44 0 0 0 0 16 0 16 0 0 2 37 140 143 169 203 224 239 154 2 108 81 4 115 160 113 215 11 26 23 38 150 94 18 158 227 36 114 91 246 160 21 43 91 240 58 231 121 1 0 59 ) asByteArray].
	^ xxxCache at: 1! !

WARenderLoop subclass: #SCRenderLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCRenderLoop methodsFor: 'accessing' stamp: 'cds 6/19/2004 18:43'!
root
	^root! !

WATask subclass: #SCDoNothingTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Examples'!

!SCDoNothingTask methodsFor: 'rendering' stamp: 'cds 1/11/2006 16:26'!
go
	^self! !

WATask subclass: #SCRunnerTask
	instanceVariableNames: 'componentClass initializationBlock createComponentBlock answerChecker checker component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 16:09'!
answerChecker
	^checker! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 16:24'!
component
	^component! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 15:46'!
componentClass
	^componentClass! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 15:46'!
componentClass: anObject
	componentClass := anObject! !

!SCRunnerTask methodsFor: 'rendering' stamp: 'cds 1/11/2006 16:08'!
createComponent
	component := createComponentBlock ifNil: [componentClass new] ifNotNil: [createComponentBlock value].
	checker := SCAnswerChecker new.
	initializationBlock ifNotNil: [initializationBlock value: component].
	component addDecoration: checker.
	^ component! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 15:59'!
createComponentBlock
	^createComponentBlock! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 15:59'!
createComponentBlock: anObject
	createComponentBlock := anObject! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'mb 8/3/2007 16:44'!
description
	"Polymorphism with WAComponent class method"
	^self componentClass description! !

!SCRunnerTask methodsFor: 'rendering' stamp: 'cds 1/11/2006 16:08'!
go
	self createComponent.
	self call: component.
	self inform: 'Component answered'! !

!SCRunnerTask methodsFor: 'hacks' stamp: 'cds 1/17/2006 13:13'!
hasTestSuite
	^false! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 15:59'!
initializationBlock
	^initializationBlock! !

!SCRunnerTask methodsFor: 'accessing' stamp: 'cds 1/11/2006 15:59'!
initializationBlock: anObject
	initializationBlock := anObject! !

!SCRunnerTask methodsFor: 'hacks' stamp: 'cds 1/11/2006 15:48'!
new
	"We pretend like we're a class...sorry"
	^self! !

WASession subclass: #SCTestBuilderSession
	instanceVariableNames: 'testBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestBuilderSession methodsFor: 'request handling' stamp: 'cds 6/29/2005 12:01'!
performRequest: aRequest 
	self testBuilder ifNotNilDo: [:tb | tb submittedRequest: aRequest].
	super performRequest: aRequest! !

!SCTestBuilderSession methodsFor: 'accessing' stamp: 'cds 6/29/2005 11:38'!
testBuilder
	^testBuilder! !

!SCTestBuilderSession methodsFor: 'accessing' stamp: 'cds 6/29/2005 11:38'!
testBuilder: anObject
	testBuilder := anObject! !

WAWalkbackErrorHandler subclass: #SCTestErrorHandler
	instanceVariableNames: 'case'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCTestErrorHandler methodsFor: 'accessing' stamp: 'cds 7/18/2004 00:28'!
case
	^case! !

!SCTestErrorHandler methodsFor: 'accessing' stamp: 'cds 7/18/2004 00:28'!
case: anObject
	case := anObject! !

!SCTestErrorHandler methodsFor: 'actions' stamp: 'cds 7/19/2004 16:59'!
handleError: e 
	self case errorOccurred: e.
	super handleError: e! !

WARenderLoopMain subclass: #SCTestCaseMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-TestRunner'!

!SCTestCaseMain methodsFor: 'accessing' stamp: 'cds 11/13/2005 14:33'!
start: aRequest
	| root |
	root := self createRoot.
	(aRequest fields includesKey: 'filter')
		ifTrue: [root filterString: (aRequest fields at: 'filter')].
	(WARenderLoop new root: root) run! !

WARenderLoopMain subclass: #SCTestingPseudomain
	instanceVariableNames: 'renderLoop storedSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideTesting-Core'!

!SCTestingPseudomain methodsFor: 'hack' stamp: 'cds 1/11/2006 15:49'!
new
	"We pretend like we're a class...sorry"
	^self! !

!SCTestingPseudomain methodsFor: 'accessing' stamp: 'mb 9/25/2007 23:37'!
start: aRequest 
	storedSession := self session.
	self session redirect.
	(renderLoop := SCRenderLoop new root: self createRoot) run! !

!SCTestingPseudomain methodsFor: 'accessing' stamp: 'cds 9/7/2004 22:59'!
storedSession
	^ storedSession! !
SCTestCaseViewer initialize!
SCTestRunner initialize!
